/* valaccodeblock.c generated by valac, the Vala compiler
 * generated from valaccodeblock.vala, do not modify */

/* valaccodeblock.vala
 *
 * Copyright (C) 2006-2008  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "valaccode.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_ccode_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_node_unref (var), NULL)))

struct _ValaCCodeBlockPrivate {
	gboolean _suppress_newline;
	ValaList* statements;
};

static gint ValaCCodeBlock_private_offset;
static gpointer vala_ccode_block_parent_class = NULL;

static void vala_ccode_block_real_write (ValaCCodeNode* base,
                                  ValaCCodeWriter* writer);
static void vala_ccode_block_finalize (ValaCCodeNode * obj);
static GType vala_ccode_block_get_type_once (void);

static inline gpointer
vala_ccode_block_get_instance_private (ValaCCodeBlock* self)
{
	return G_STRUCT_MEMBER_P (self, ValaCCodeBlock_private_offset);
}

gboolean
vala_ccode_block_get_suppress_newline (ValaCCodeBlock* self)
{
	gboolean result;
#line 33 "valaccodeblock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "valaccodeblock.vala"
	result = self->priv->_suppress_newline;
#line 33 "valaccodeblock.vala"
	return result;
#line 70 "valaccodeblock.c"
}

void
vala_ccode_block_set_suppress_newline (ValaCCodeBlock* self,
                                       gboolean value)
{
#line 33 "valaccodeblock.vala"
	g_return_if_fail (self != NULL);
#line 33 "valaccodeblock.vala"
	self->priv->_suppress_newline = value;
#line 81 "valaccodeblock.c"
}

/**
 * Prepend the specified statement to the list of statements.
 */
void
vala_ccode_block_prepend_statement (ValaCCodeBlock* self,
                                    ValaCCodeNode* statement)
{
	ValaList* _tmp0_;
#line 40 "valaccodeblock.vala"
	g_return_if_fail (self != NULL);
#line 40 "valaccodeblock.vala"
	g_return_if_fail (statement != NULL);
#line 41 "valaccodeblock.vala"
	_tmp0_ = self->priv->statements;
#line 41 "valaccodeblock.vala"
	vala_list_insert (_tmp0_, 0, statement);
#line 100 "valaccodeblock.c"
}

/**
 * Append the specified statement to the list of statements.
 */
void
vala_ccode_block_add_statement (ValaCCodeBlock* self,
                                ValaCCodeNode* statement)
{
	ValaList* _tmp0_;
#line 47 "valaccodeblock.vala"
	g_return_if_fail (self != NULL);
#line 47 "valaccodeblock.vala"
	g_return_if_fail (statement != NULL);
#line 49 "valaccodeblock.vala"
	_tmp0_ = self->priv->statements;
#line 49 "valaccodeblock.vala"
	vala_collection_add ((ValaCollection*) _tmp0_, statement);
#line 119 "valaccodeblock.c"
}

static gpointer
_vala_ccode_node_ref0 (gpointer self)
{
#line 65 "valaccodeblock.vala"
	return self ? vala_ccode_node_ref (self) : NULL;
#line 127 "valaccodeblock.c"
}

static void
vala_ccode_block_real_write (ValaCCodeNode* base,
                             ValaCCodeWriter* writer)
{
	ValaCCodeBlock * self;
	ValaCCodeNode* last_statement = NULL;
	gboolean _tmp32_;
#line 52 "valaccodeblock.vala"
	self = (ValaCCodeBlock*) base;
#line 52 "valaccodeblock.vala"
	g_return_if_fail (writer != NULL);
#line 54 "valaccodeblock.vala"
	last_statement = NULL;
#line 56 "valaccodeblock.vala"
	vala_ccode_writer_write_begin_block (writer);
#line 145 "valaccodeblock.c"
	{
		ValaList* _statement_list = NULL;
		ValaList* _tmp0_;
		gint _statement_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _statement_index = 0;
#line 57 "valaccodeblock.vala"
		_tmp0_ = self->priv->statements;
#line 57 "valaccodeblock.vala"
		_statement_list = _tmp0_;
#line 57 "valaccodeblock.vala"
		_tmp1_ = _statement_list;
#line 57 "valaccodeblock.vala"
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
#line 57 "valaccodeblock.vala"
		_tmp3_ = _tmp2_;
#line 57 "valaccodeblock.vala"
		_statement_size = _tmp3_;
#line 57 "valaccodeblock.vala"
		_statement_index = -1;
#line 57 "valaccodeblock.vala"
		while (TRUE) {
#line 170 "valaccodeblock.c"
			gint _tmp4_;
			gint _tmp5_;
			ValaCCodeNode* statement = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaCCodeNode* _tmp8_;
			gboolean _tmp9_ = FALSE;
			ValaCCodeNode* _tmp10_;
#line 57 "valaccodeblock.vala"
			_statement_index = _statement_index + 1;
#line 57 "valaccodeblock.vala"
			_tmp4_ = _statement_index;
#line 57 "valaccodeblock.vala"
			_tmp5_ = _statement_size;
#line 57 "valaccodeblock.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 57 "valaccodeblock.vala"
				break;
#line 189 "valaccodeblock.c"
			}
#line 57 "valaccodeblock.vala"
			_tmp6_ = _statement_list;
#line 57 "valaccodeblock.vala"
			_tmp7_ = vala_list_get (_tmp6_, _statement_index);
#line 57 "valaccodeblock.vala"
			statement = (ValaCCodeNode*) _tmp7_;
#line 58 "valaccodeblock.vala"
			_tmp8_ = statement;
#line 58 "valaccodeblock.vala"
			vala_ccode_node_write_declaration (_tmp8_, writer);
#line 61 "valaccodeblock.vala"
			_tmp10_ = statement;
#line 61 "valaccodeblock.vala"
			if (VALA_IS_CCODE_LABEL (_tmp10_)) {
#line 61 "valaccodeblock.vala"
				_tmp9_ = TRUE;
#line 207 "valaccodeblock.c"
			} else {
				ValaCCodeNode* _tmp11_;
#line 61 "valaccodeblock.vala"
				_tmp11_ = statement;
#line 61 "valaccodeblock.vala"
				_tmp9_ = VALA_IS_CCODE_CASE_STATEMENT (_tmp11_);
#line 214 "valaccodeblock.c"
			}
#line 61 "valaccodeblock.vala"
			if (_tmp9_) {
#line 62 "valaccodeblock.vala"
				_vala_ccode_node_unref0 (last_statement);
#line 62 "valaccodeblock.vala"
				last_statement = NULL;
#line 222 "valaccodeblock.c"
			} else {
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				ValaCCodeNode* _tmp15_;
#line 63 "valaccodeblock.vala"
				_tmp15_ = statement;
#line 63 "valaccodeblock.vala"
				if (VALA_IS_CCODE_RETURN_STATEMENT (_tmp15_)) {
#line 63 "valaccodeblock.vala"
					_tmp14_ = TRUE;
#line 234 "valaccodeblock.c"
				} else {
					ValaCCodeNode* _tmp16_;
#line 63 "valaccodeblock.vala"
					_tmp16_ = statement;
#line 63 "valaccodeblock.vala"
					_tmp14_ = VALA_IS_CCODE_GOTO_STATEMENT (_tmp16_);
#line 241 "valaccodeblock.c"
				}
#line 63 "valaccodeblock.vala"
				if (_tmp14_) {
#line 63 "valaccodeblock.vala"
					_tmp13_ = TRUE;
#line 247 "valaccodeblock.c"
				} else {
					ValaCCodeNode* _tmp17_;
#line 64 "valaccodeblock.vala"
					_tmp17_ = statement;
#line 64 "valaccodeblock.vala"
					_tmp13_ = VALA_IS_CCODE_CONTINUE_STATEMENT (_tmp17_);
#line 254 "valaccodeblock.c"
				}
#line 63 "valaccodeblock.vala"
				if (_tmp13_) {
#line 63 "valaccodeblock.vala"
					_tmp12_ = TRUE;
#line 260 "valaccodeblock.c"
				} else {
					ValaCCodeNode* _tmp18_;
#line 64 "valaccodeblock.vala"
					_tmp18_ = statement;
#line 64 "valaccodeblock.vala"
					_tmp12_ = VALA_IS_CCODE_BREAK_STATEMENT (_tmp18_);
#line 267 "valaccodeblock.c"
				}
#line 63 "valaccodeblock.vala"
				if (_tmp12_) {
#line 271 "valaccodeblock.c"
					ValaCCodeNode* _tmp19_;
					ValaCCodeNode* _tmp20_;
#line 65 "valaccodeblock.vala"
					_tmp19_ = statement;
#line 65 "valaccodeblock.vala"
					_tmp20_ = _vala_ccode_node_ref0 (_tmp19_);
#line 65 "valaccodeblock.vala"
					_vala_ccode_node_unref0 (last_statement);
#line 65 "valaccodeblock.vala"
					last_statement = _tmp20_;
#line 282 "valaccodeblock.c"
				}
			}
#line 57 "valaccodeblock.vala"
			_vala_ccode_node_unref0 (statement);
#line 287 "valaccodeblock.c"
		}
	}
	{
		ValaList* _statement_list = NULL;
		ValaList* _tmp21_;
		gint _statement_size = 0;
		ValaList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _statement_index = 0;
#line 69 "valaccodeblock.vala"
		_tmp21_ = self->priv->statements;
#line 69 "valaccodeblock.vala"
		_statement_list = _tmp21_;
#line 69 "valaccodeblock.vala"
		_tmp22_ = _statement_list;
#line 69 "valaccodeblock.vala"
		_tmp23_ = vala_collection_get_size ((ValaCollection*) _tmp22_);
#line 69 "valaccodeblock.vala"
		_tmp24_ = _tmp23_;
#line 69 "valaccodeblock.vala"
		_statement_size = _tmp24_;
#line 69 "valaccodeblock.vala"
		_statement_index = -1;
#line 69 "valaccodeblock.vala"
		while (TRUE) {
#line 314 "valaccodeblock.c"
			gint _tmp25_;
			gint _tmp26_;
			ValaCCodeNode* statement = NULL;
			ValaList* _tmp27_;
			gpointer _tmp28_;
			ValaCCodeNode* _tmp29_;
			ValaCCodeNode* _tmp30_;
			ValaCCodeNode* _tmp31_;
#line 69 "valaccodeblock.vala"
			_statement_index = _statement_index + 1;
#line 69 "valaccodeblock.vala"
			_tmp25_ = _statement_index;
#line 69 "valaccodeblock.vala"
			_tmp26_ = _statement_size;
#line 69 "valaccodeblock.vala"
			if (!(_tmp25_ < _tmp26_)) {
#line 69 "valaccodeblock.vala"
				break;
#line 333 "valaccodeblock.c"
			}
#line 69 "valaccodeblock.vala"
			_tmp27_ = _statement_list;
#line 69 "valaccodeblock.vala"
			_tmp28_ = vala_list_get (_tmp27_, _statement_index);
#line 69 "valaccodeblock.vala"
			statement = (ValaCCodeNode*) _tmp28_;
#line 70 "valaccodeblock.vala"
			_tmp29_ = statement;
#line 70 "valaccodeblock.vala"
			vala_ccode_node_write (_tmp29_, writer);
#line 73 "valaccodeblock.vala"
			_tmp30_ = statement;
#line 73 "valaccodeblock.vala"
			_tmp31_ = last_statement;
#line 73 "valaccodeblock.vala"
			if (_tmp30_ == _tmp31_) {
#line 74 "valaccodeblock.vala"
				_vala_ccode_node_unref0 (statement);
#line 74 "valaccodeblock.vala"
				break;
#line 355 "valaccodeblock.c"
			}
#line 69 "valaccodeblock.vala"
			_vala_ccode_node_unref0 (statement);
#line 359 "valaccodeblock.c"
		}
	}
#line 78 "valaccodeblock.vala"
	vala_ccode_writer_write_end_block (writer);
#line 80 "valaccodeblock.vala"
	_tmp32_ = self->priv->_suppress_newline;
#line 80 "valaccodeblock.vala"
	if (!_tmp32_) {
#line 81 "valaccodeblock.vala"
		vala_ccode_writer_write_newline (writer);
#line 370 "valaccodeblock.c"
	}
#line 52 "valaccodeblock.vala"
	_vala_ccode_node_unref0 (last_statement);
#line 374 "valaccodeblock.c"
}

ValaCCodeBlock*
vala_ccode_block_construct (GType object_type)
{
	ValaCCodeBlock* self = NULL;
#line 28 "valaccodeblock.vala"
	self = (ValaCCodeBlock*) vala_ccode_statement_construct (object_type);
#line 28 "valaccodeblock.vala"
	return self;
#line 385 "valaccodeblock.c"
}

ValaCCodeBlock*
vala_ccode_block_new (void)
{
#line 28 "valaccodeblock.vala"
	return vala_ccode_block_construct (VALA_TYPE_CCODE_BLOCK);
#line 393 "valaccodeblock.c"
}

static void
vala_ccode_block_class_init (ValaCCodeBlockClass * klass,
                             gpointer klass_data)
{
#line 28 "valaccodeblock.vala"
	vala_ccode_block_parent_class = g_type_class_peek_parent (klass);
#line 28 "valaccodeblock.vala"
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_block_finalize;
#line 28 "valaccodeblock.vala"
	g_type_class_adjust_private_offset (klass, &ValaCCodeBlock_private_offset);
#line 28 "valaccodeblock.vala"
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode*, ValaCCodeWriter*)) vala_ccode_block_real_write;
#line 408 "valaccodeblock.c"
}

static void
vala_ccode_block_instance_init (ValaCCodeBlock * self,
                                gpointer klass)
{
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
#line 28 "valaccodeblock.vala"
	self->priv = vala_ccode_block_get_instance_private (self);
#line 35 "valaccodeblock.vala"
	_tmp0_ = g_direct_equal;
#line 35 "valaccodeblock.vala"
	_tmp1_ = vala_array_list_new (VALA_TYPE_CCODE_NODE, (GBoxedCopyFunc) vala_ccode_node_ref, (GDestroyNotify) vala_ccode_node_unref, _tmp0_);
#line 35 "valaccodeblock.vala"
	self->priv->statements = (ValaList*) _tmp1_;
#line 425 "valaccodeblock.c"
}

static void
vala_ccode_block_finalize (ValaCCodeNode * obj)
{
	ValaCCodeBlock * self;
#line 28 "valaccodeblock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_BLOCK, ValaCCodeBlock);
#line 35 "valaccodeblock.vala"
	_vala_iterable_unref0 (self->priv->statements);
#line 28 "valaccodeblock.vala"
	VALA_CCODE_NODE_CLASS (vala_ccode_block_parent_class)->finalize (obj);
#line 438 "valaccodeblock.c"
}

/**
 * Represents a C code block.
 */
static GType
vala_ccode_block_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeBlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeBlock), 0, (GInstanceInitFunc) vala_ccode_block_instance_init, NULL };
	GType vala_ccode_block_type_id;
	vala_ccode_block_type_id = g_type_register_static (VALA_TYPE_CCODE_STATEMENT, "ValaCCodeBlock", &g_define_type_info, 0);
	ValaCCodeBlock_private_offset = g_type_add_instance_private (vala_ccode_block_type_id, sizeof (ValaCCodeBlockPrivate));
	return vala_ccode_block_type_id;
}

GType
vala_ccode_block_get_type (void)
{
	static volatile gsize vala_ccode_block_type_id__once = 0;
	if (g_once_init_enter (&vala_ccode_block_type_id__once)) {
		GType vala_ccode_block_type_id;
		vala_ccode_block_type_id = vala_ccode_block_get_type_once ();
		g_once_init_leave (&vala_ccode_block_type_id__once, vala_ccode_block_type_id);
	}
	return vala_ccode_block_type_id__once;
}

