/* valaccodefile.c generated by valac, the Vala compiler
 * generated from valaccodefile.vala, do not modify */

/* valaccodefile.vala
 *
 * Copyright (C) 2009-2011  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "valaccode.h"
#include <vala.h>
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_ccode_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_node_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_ccode_writer_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_writer_unref (var), NULL)))
typedef struct _ValaParamSpecCCodeFile ValaParamSpecCCodeFile;

struct _ValaCCodeFilePrivate {
	CCodeFileType _file_type;
	ValaSourceFile* _file;
	ValaSet* features;
	ValaSet* declarations;
	ValaSet* definitions;
	ValaSet* includes;
	ValaCCodeFragment* comments;
	ValaCCodeFragment* feature_test_macros;
	ValaCCodeFragment* define_directives;
	ValaCCodeFragment* include_directives;
	ValaCCodeFragment* type_declaration;
	ValaCCodeFragment* type_definition;
	ValaCCodeFragment* type_member_declaration;
	ValaCCodeFragment* constant_declaration;
	ValaCCodeFragment* type_member_definition;
};

struct _ValaParamSpecCCodeFile {
	GParamSpec parent_instance;
};

static gint ValaCCodeFile_private_offset;
static gpointer vala_ccode_file_parent_class = NULL;

static void vala_ccode_file_set_file_type (ValaCCodeFile* self,
                                    CCodeFileType value);
static void vala_ccode_file_set_file (ValaCCodeFile* self,
                               ValaSourceFile* value);
static void vala_ccode_file_get_symbols_from_fragment (ValaCCodeFile* self,
                                                ValaList* symbols,
                                                ValaCCodeFragment* fragment);
static gchar* vala_ccode_file_get_define_for_filename (const gchar* filename);
static void vala_ccode_file_write_compiler_compatibility (ValaCCodeWriter* writer);
static void vala_ccode_file_write_compiler_compatibility_pragma_warning (ValaCCodeWriter* writer,
                                                                  const gchar* compiler,
                                                                  const gchar* warning);
static void vala_ccode_file_finalize (ValaCCodeFile * obj);
static GType vala_ccode_file_get_type_once (void);

static inline gpointer
vala_ccode_file_get_instance_private (ValaCCodeFile* self)
{
	return G_STRUCT_MEMBER_P (self, ValaCCodeFile_private_offset);
}

CCodeFileType
vala_ccode_file_get_file_type (ValaCCodeFile* self)
{
	CCodeFileType result;
#line 25 "valaccodefile.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 25 "valaccodefile.vala"
	result = self->priv->_file_type;
#line 25 "valaccodefile.vala"
	return result;
#line 105 "valaccodefile.c"
}

static void
vala_ccode_file_set_file_type (ValaCCodeFile* self,
                               CCodeFileType value)
{
#line 25 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 25 "valaccodefile.vala"
	self->priv->_file_type = value;
#line 116 "valaccodefile.c"
}

ValaSourceFile*
vala_ccode_file_get_file (ValaCCodeFile* self)
{
	ValaSourceFile* result;
	ValaSourceFile* _tmp0_;
#line 27 "valaccodefile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "valaccodefile.vala"
	_tmp0_ = self->priv->_file;
#line 27 "valaccodefile.vala"
	result = _tmp0_;
#line 27 "valaccodefile.vala"
	return result;
#line 132 "valaccodefile.c"
}

static void
vala_ccode_file_set_file (ValaCCodeFile* self,
                          ValaSourceFile* value)
{
#line 27 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 27 "valaccodefile.vala"
	self->priv->_file = value;
#line 143 "valaccodefile.c"
}

ValaCCodeFile*
vala_ccode_file_construct (GType object_type,
                           CCodeFileType type,
                           ValaSourceFile* source_file)
{
	ValaCCodeFile* self = NULL;
#line 43 "valaccodefile.vala"
	self = (ValaCCodeFile*) g_type_create_instance (object_type);
#line 44 "valaccodefile.vala"
	vala_ccode_file_set_file (self, source_file);
#line 45 "valaccodefile.vala"
	vala_ccode_file_set_file_type (self, type);
#line 43 "valaccodefile.vala"
	return self;
#line 160 "valaccodefile.c"
}

ValaCCodeFile*
vala_ccode_file_new (CCodeFileType type,
                     ValaSourceFile* source_file)
{
#line 43 "valaccodefile.vala"
	return vala_ccode_file_construct (VALA_TYPE_CCODE_FILE, type, source_file);
#line 169 "valaccodefile.c"
}

gboolean
vala_ccode_file_add_declaration (ValaCCodeFile* self,
                                 const gchar* name)
{
	ValaSet* _tmp0_;
	ValaSet* _tmp1_;
	gboolean result;
#line 48 "valaccodefile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "valaccodefile.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 49 "valaccodefile.vala"
	_tmp0_ = self->priv->declarations;
#line 49 "valaccodefile.vala"
	if (vala_collection_contains ((ValaCollection*) _tmp0_, name)) {
#line 50 "valaccodefile.vala"
		result = TRUE;
#line 50 "valaccodefile.vala"
		return result;
#line 191 "valaccodefile.c"
	}
#line 52 "valaccodefile.vala"
	_tmp1_ = self->priv->declarations;
#line 52 "valaccodefile.vala"
	vala_collection_add ((ValaCollection*) _tmp1_, name);
#line 53 "valaccodefile.vala"
	result = FALSE;
#line 53 "valaccodefile.vala"
	return result;
#line 201 "valaccodefile.c"
}

void
vala_ccode_file_add_comment (ValaCCodeFile* self,
                             ValaCCodeComment* comment)
{
	ValaCCodeFragment* _tmp0_;
#line 56 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 56 "valaccodefile.vala"
	g_return_if_fail (comment != NULL);
#line 57 "valaccodefile.vala"
	_tmp0_ = self->priv->comments;
#line 57 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, (ValaCCodeNode*) comment);
#line 217 "valaccodefile.c"
}

void
vala_ccode_file_add_feature_test_macro (ValaCCodeFile* self,
                                        const gchar* feature_test_macro)
{
	ValaSet* _tmp0_;
#line 60 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 60 "valaccodefile.vala"
	g_return_if_fail (feature_test_macro != NULL);
#line 61 "valaccodefile.vala"
	_tmp0_ = self->priv->features;
#line 61 "valaccodefile.vala"
	if (!vala_collection_contains ((ValaCollection*) _tmp0_, feature_test_macro)) {
#line 233 "valaccodefile.c"
		ValaCCodeFragment* _tmp1_;
		ValaCCodeDefine* _tmp2_;
		ValaCCodeDefine* _tmp3_;
		ValaSet* _tmp4_;
#line 62 "valaccodefile.vala"
		_tmp1_ = self->priv->feature_test_macros;
#line 62 "valaccodefile.vala"
		_tmp2_ = vala_ccode_define_new (feature_test_macro, NULL);
#line 62 "valaccodefile.vala"
		_tmp3_ = _tmp2_;
#line 62 "valaccodefile.vala"
		vala_ccode_fragment_append (_tmp1_, (ValaCCodeNode*) _tmp3_);
#line 62 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp3_);
#line 63 "valaccodefile.vala"
		_tmp4_ = self->priv->features;
#line 63 "valaccodefile.vala"
		vala_collection_add ((ValaCollection*) _tmp4_, feature_test_macro);
#line 252 "valaccodefile.c"
	}
}

void
vala_ccode_file_add_include (ValaCCodeFile* self,
                             const gchar* filename,
                             gboolean local)
{
	ValaSet* _tmp0_;
#line 67 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 67 "valaccodefile.vala"
	g_return_if_fail (filename != NULL);
#line 68 "valaccodefile.vala"
	_tmp0_ = self->priv->includes;
#line 68 "valaccodefile.vala"
	if (!vala_collection_contains ((ValaCollection*) _tmp0_, filename)) {
#line 270 "valaccodefile.c"
		ValaCCodeFragment* _tmp1_;
		ValaCCodeIncludeDirective* _tmp2_;
		ValaCCodeIncludeDirective* _tmp3_;
		ValaSet* _tmp4_;
#line 69 "valaccodefile.vala"
		_tmp1_ = self->priv->include_directives;
#line 69 "valaccodefile.vala"
		_tmp2_ = vala_ccode_include_directive_new (filename, local);
#line 69 "valaccodefile.vala"
		_tmp3_ = _tmp2_;
#line 69 "valaccodefile.vala"
		vala_ccode_fragment_append (_tmp1_, (ValaCCodeNode*) _tmp3_);
#line 69 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp3_);
#line 70 "valaccodefile.vala"
		_tmp4_ = self->priv->includes;
#line 70 "valaccodefile.vala"
		vala_collection_add ((ValaCollection*) _tmp4_, filename);
#line 289 "valaccodefile.c"
	}
}

void
vala_ccode_file_add_define (ValaCCodeFile* self,
                            ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 74 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 74 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 75 "valaccodefile.vala"
	_tmp0_ = self->priv->define_directives;
#line 75 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 306 "valaccodefile.c"
}

void
vala_ccode_file_add_type_declaration (ValaCCodeFile* self,
                                      ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 78 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 78 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 79 "valaccodefile.vala"
	_tmp0_ = self->priv->type_declaration;
#line 79 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 322 "valaccodefile.c"
}

void
vala_ccode_file_add_type_definition (ValaCCodeFile* self,
                                     ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 82 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 82 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 83 "valaccodefile.vala"
	_tmp0_ = self->priv->type_definition;
#line 83 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 338 "valaccodefile.c"
}

void
vala_ccode_file_add_type_member_declaration (ValaCCodeFile* self,
                                             ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 86 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 86 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 87 "valaccodefile.vala"
	_tmp0_ = self->priv->type_member_declaration;
#line 87 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 354 "valaccodefile.c"
}

void
vala_ccode_file_add_constant_declaration (ValaCCodeFile* self,
                                          ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 90 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 90 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 91 "valaccodefile.vala"
	_tmp0_ = self->priv->constant_declaration;
#line 91 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 370 "valaccodefile.c"
}

void
vala_ccode_file_add_type_member_definition (ValaCCodeFile* self,
                                            ValaCCodeNode* node)
{
	ValaCCodeFragment* _tmp0_;
#line 94 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 94 "valaccodefile.vala"
	g_return_if_fail (node != NULL);
#line 95 "valaccodefile.vala"
	_tmp0_ = self->priv->type_member_definition;
#line 95 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp0_, node);
#line 386 "valaccodefile.c"
}

void
vala_ccode_file_add_function_declaration (ValaCCodeFile* self,
                                          ValaCCodeFunction* func)
{
	ValaSet* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	ValaCCodeFunction* decl = NULL;
	ValaCCodeFunction* _tmp3_;
	ValaCCodeFragment* _tmp4_;
#line 98 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 98 "valaccodefile.vala"
	g_return_if_fail (func != NULL);
#line 99 "valaccodefile.vala"
	_tmp0_ = self->priv->declarations;
#line 99 "valaccodefile.vala"
	_tmp1_ = vala_ccode_function_get_name (func);
#line 99 "valaccodefile.vala"
	_tmp2_ = _tmp1_;
#line 99 "valaccodefile.vala"
	vala_collection_add ((ValaCollection*) _tmp0_, _tmp2_);
#line 101 "valaccodefile.vala"
	_tmp3_ = vala_ccode_function_copy (func);
#line 101 "valaccodefile.vala"
	decl = _tmp3_;
#line 102 "valaccodefile.vala"
	vala_ccode_function_set_is_declaration (decl, TRUE);
#line 103 "valaccodefile.vala"
	_tmp4_ = self->priv->type_member_declaration;
#line 103 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp4_, (ValaCCodeNode*) decl);
#line 98 "valaccodefile.vala"
	_vala_ccode_node_unref0 (decl);
#line 423 "valaccodefile.c"
}

void
vala_ccode_file_add_function (ValaCCodeFile* self,
                              ValaCCodeFunction* func)
{
	ValaSet* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	ValaCCodeFragment* _tmp5_;
#line 106 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 106 "valaccodefile.vala"
	g_return_if_fail (func != NULL);
#line 107 "valaccodefile.vala"
	_tmp0_ = self->priv->definitions;
#line 107 "valaccodefile.vala"
	_tmp1_ = vala_ccode_function_get_name (func);
#line 107 "valaccodefile.vala"
	_tmp2_ = _tmp1_;
#line 107 "valaccodefile.vala"
	if (!vala_collection_add ((ValaCollection*) _tmp0_, _tmp2_)) {
#line 446 "valaccodefile.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 108 "valaccodefile.vala"
		_tmp3_ = vala_ccode_function_get_name (func);
#line 108 "valaccodefile.vala"
		_tmp4_ = _tmp3_;
#line 108 "valaccodefile.vala"
		vala_report_error (NULL, "internal: Redefinition of `%s'", _tmp4_);
#line 109 "valaccodefile.vala"
		return;
#line 457 "valaccodefile.c"
	}
#line 112 "valaccodefile.vala"
	_tmp5_ = self->priv->type_member_definition;
#line 112 "valaccodefile.vala"
	vala_ccode_fragment_append (_tmp5_, (ValaCCodeNode*) func);
#line 463 "valaccodefile.c"
}

ValaList*
vala_ccode_file_get_symbols (ValaCCodeFile* self)
{
	ValaArrayList* symbols = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	ValaCCodeFragment* _tmp2_;
	ValaList* result;
#line 115 "valaccodefile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "valaccodefile.vala"
	_tmp0_ = g_str_equal;
#line 116 "valaccodefile.vala"
	_tmp1_ = vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp0_);
#line 116 "valaccodefile.vala"
	symbols = _tmp1_;
#line 117 "valaccodefile.vala"
	_tmp2_ = self->priv->type_member_declaration;
#line 117 "valaccodefile.vala"
	vala_ccode_file_get_symbols_from_fragment (self, (ValaList*) symbols, _tmp2_);
#line 118 "valaccodefile.vala"
	result = (ValaList*) symbols;
#line 118 "valaccodefile.vala"
	return result;
#line 490 "valaccodefile.c"
}

static gpointer
_vala_ccode_node_ref0 (gpointer self)
{
#line 126 "valaccodefile.vala"
	return self ? vala_ccode_node_ref (self) : NULL;
#line 498 "valaccodefile.c"
}

static void
vala_ccode_file_get_symbols_from_fragment (ValaCCodeFile* self,
                                           ValaList* symbols,
                                           ValaCCodeFragment* fragment)
{
#line 121 "valaccodefile.vala"
	g_return_if_fail (self != NULL);
#line 121 "valaccodefile.vala"
	g_return_if_fail (symbols != NULL);
#line 121 "valaccodefile.vala"
	g_return_if_fail (fragment != NULL);
#line 512 "valaccodefile.c"
	{
		ValaList* _node_list = NULL;
		ValaList* _tmp0_;
		gint _node_size = 0;
		ValaList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _node_index = 0;
#line 122 "valaccodefile.vala"
		_tmp0_ = vala_ccode_fragment_get_children (fragment);
#line 122 "valaccodefile.vala"
		_node_list = _tmp0_;
#line 122 "valaccodefile.vala"
		_tmp1_ = _node_list;
#line 122 "valaccodefile.vala"
		_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
#line 122 "valaccodefile.vala"
		_tmp3_ = _tmp2_;
#line 122 "valaccodefile.vala"
		_node_size = _tmp3_;
#line 122 "valaccodefile.vala"
		_node_index = -1;
#line 122 "valaccodefile.vala"
		while (TRUE) {
#line 537 "valaccodefile.c"
			gint _tmp4_;
			gint _tmp5_;
			ValaCCodeNode* node = NULL;
			ValaList* _tmp6_;
			gpointer _tmp7_;
			ValaCCodeNode* _tmp8_;
#line 122 "valaccodefile.vala"
			_node_index = _node_index + 1;
#line 122 "valaccodefile.vala"
			_tmp4_ = _node_index;
#line 122 "valaccodefile.vala"
			_tmp5_ = _node_size;
#line 122 "valaccodefile.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 122 "valaccodefile.vala"
				break;
#line 554 "valaccodefile.c"
			}
#line 122 "valaccodefile.vala"
			_tmp6_ = _node_list;
#line 122 "valaccodefile.vala"
			_tmp7_ = vala_list_get (_tmp6_, _node_index);
#line 122 "valaccodefile.vala"
			node = (ValaCCodeNode*) _tmp7_;
#line 123 "valaccodefile.vala"
			_tmp8_ = node;
#line 123 "valaccodefile.vala"
			if (VALA_IS_CCODE_FRAGMENT (_tmp8_)) {
#line 566 "valaccodefile.c"
				ValaCCodeNode* _tmp9_;
#line 124 "valaccodefile.vala"
				_tmp9_ = node;
#line 124 "valaccodefile.vala"
				vala_ccode_file_get_symbols_from_fragment (self, symbols, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, VALA_TYPE_CCODE_FRAGMENT, ValaCCodeFragment));
#line 572 "valaccodefile.c"
			} else {
				ValaCCodeFunction* func = NULL;
				ValaCCodeNode* _tmp10_;
				ValaCCodeFunction* _tmp11_;
				ValaCCodeFunction* _tmp12_;
#line 126 "valaccodefile.vala"
				_tmp10_ = node;
#line 126 "valaccodefile.vala"
				_tmp11_ = _vala_ccode_node_ref0 (VALA_IS_CCODE_FUNCTION (_tmp10_) ? ((ValaCCodeFunction*) _tmp10_) : NULL);
#line 126 "valaccodefile.vala"
				func = _tmp11_;
#line 127 "valaccodefile.vala"
				_tmp12_ = func;
#line 127 "valaccodefile.vala"
				if (_tmp12_ != NULL) {
#line 588 "valaccodefile.c"
					ValaCCodeFunction* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 128 "valaccodefile.vala"
					_tmp13_ = func;
#line 128 "valaccodefile.vala"
					_tmp14_ = vala_ccode_function_get_name (_tmp13_);
#line 128 "valaccodefile.vala"
					_tmp15_ = _tmp14_;
#line 128 "valaccodefile.vala"
					vala_collection_add ((ValaCollection*) symbols, _tmp15_);
#line 600 "valaccodefile.c"
				}
#line 123 "valaccodefile.vala"
				_vala_ccode_node_unref0 (func);
#line 604 "valaccodefile.c"
			}
#line 122 "valaccodefile.vala"
			_vala_ccode_node_unref0 (node);
#line 608 "valaccodefile.c"
		}
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 624 "valaccodefile.c"
}

static gchar*
vala_ccode_file_get_define_for_filename (const gchar* filename)
{
	GString* define = NULL;
	GString* _tmp0_;
	gchar* i = NULL;
	gchar* _tmp1_;
	GString* _tmp12_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* result;
#line 134 "valaccodefile.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 135 "valaccodefile.vala"
	_tmp0_ = g_string_new ("__");
#line 135 "valaccodefile.vala"
	define = _tmp0_;
#line 137 "valaccodefile.vala"
	_tmp1_ = g_strdup (filename);
#line 137 "valaccodefile.vala"
	i = _tmp1_;
#line 138 "valaccodefile.vala"
	while (TRUE) {
#line 651 "valaccodefile.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gunichar c = 0U;
		const gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 138 "valaccodefile.vala"
		_tmp2_ = i;
#line 138 "valaccodefile.vala"
		_tmp3_ = strlen (_tmp2_);
#line 138 "valaccodefile.vala"
		_tmp4_ = _tmp3_;
#line 138 "valaccodefile.vala"
		if (!(_tmp4_ > 0)) {
#line 138 "valaccodefile.vala"
			break;
#line 671 "valaccodefile.c"
		}
#line 139 "valaccodefile.vala"
		_tmp5_ = i;
#line 139 "valaccodefile.vala"
		c = string_get_char (_tmp5_, (glong) 0);
#line 140 "valaccodefile.vala"
		if (g_unichar_isalnum (c)) {
#line 140 "valaccodefile.vala"
			_tmp6_ = c < ((gunichar) 0x80);
#line 681 "valaccodefile.c"
		} else {
#line 140 "valaccodefile.vala"
			_tmp6_ = FALSE;
#line 685 "valaccodefile.c"
		}
#line 140 "valaccodefile.vala"
		if (_tmp6_) {
#line 689 "valaccodefile.c"
			GString* _tmp7_;
#line 141 "valaccodefile.vala"
			_tmp7_ = define;
#line 141 "valaccodefile.vala"
			g_string_append_unichar (_tmp7_, g_unichar_toupper (c));
#line 695 "valaccodefile.c"
		} else {
			GString* _tmp8_;
#line 143 "valaccodefile.vala"
			_tmp8_ = define;
#line 143 "valaccodefile.vala"
			g_string_append_c (_tmp8_, '_');
#line 702 "valaccodefile.c"
		}
#line 146 "valaccodefile.vala"
		_tmp9_ = i;
#line 146 "valaccodefile.vala"
		_tmp10_ = g_utf8_next_char (_tmp9_);
#line 146 "valaccodefile.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 146 "valaccodefile.vala"
		_g_free0 (i);
#line 146 "valaccodefile.vala"
		i = _tmp11_;
#line 714 "valaccodefile.c"
	}
#line 149 "valaccodefile.vala"
	_tmp12_ = define;
#line 149 "valaccodefile.vala"
	g_string_append (_tmp12_, "__");
#line 151 "valaccodefile.vala"
	_tmp13_ = define;
#line 151 "valaccodefile.vala"
	_tmp14_ = _tmp13_->str;
#line 151 "valaccodefile.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 151 "valaccodefile.vala"
	result = _tmp15_;
#line 151 "valaccodefile.vala"
	_g_free0 (i);
#line 151 "valaccodefile.vala"
	_g_string_free0 (define);
#line 151 "valaccodefile.vala"
	return result;
#line 734 "valaccodefile.c"
}

gboolean
vala_ccode_file_store (ValaCCodeFile* self,
                       const gchar* filename,
                       const gchar* source_filename,
                       gboolean write_version,
                       gboolean line_directives,
                       const gchar* begin_decls,
                       const gchar* end_decls)
{
	ValaCCodeWriter* writer = NULL;
	ValaCCodeWriter* _tmp0_;
	ValaCCodeWriter* _tmp1_;
	CCodeFileType _tmp2_;
	ValaCCodeWriter* _tmp96_;
	gboolean result;
#line 154 "valaccodefile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "valaccodefile.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 155 "valaccodefile.vala"
	_tmp0_ = vala_ccode_writer_new (filename, source_filename);
#line 155 "valaccodefile.vala"
	writer = _tmp0_;
#line 156 "valaccodefile.vala"
	_tmp1_ = writer;
#line 156 "valaccodefile.vala"
	if (!vala_ccode_writer_open (_tmp1_, write_version)) {
#line 157 "valaccodefile.vala"
		result = FALSE;
#line 157 "valaccodefile.vala"
		_vala_ccode_writer_unref0 (writer);
#line 157 "valaccodefile.vala"
		return result;
#line 770 "valaccodefile.c"
	}
#line 160 "valaccodefile.vala"
	_tmp2_ = self->priv->_file_type;
#line 160 "valaccodefile.vala"
	if (_tmp2_ == CCODE_FILE_TYPE_SOURCE) {
#line 776 "valaccodefile.c"
		ValaCCodeWriter* _tmp3_;
		ValaCCodeFragment* _tmp4_;
		ValaCCodeWriter* _tmp5_;
		ValaCCodeWriter* _tmp6_;
		ValaCCodeWriter* _tmp7_;
		ValaCCodeFragment* _tmp8_;
		ValaCCodeWriter* _tmp9_;
		ValaCCodeWriter* _tmp10_;
		ValaCCodeFragment* _tmp11_;
		ValaCCodeWriter* _tmp12_;
		ValaCCodeWriter* _tmp13_;
		ValaCCodeFragment* _tmp14_;
		ValaCCodeWriter* _tmp15_;
		ValaCCodeWriter* _tmp16_;
		ValaCCodeFragment* _tmp17_;
		ValaCCodeWriter* _tmp18_;
		ValaCCodeWriter* _tmp19_;
		ValaCCodeFragment* _tmp20_;
		ValaCCodeWriter* _tmp21_;
		ValaCCodeWriter* _tmp22_;
		ValaCCodeFragment* _tmp23_;
		ValaCCodeWriter* _tmp24_;
		ValaCCodeWriter* _tmp25_;
		ValaCCodeFragment* _tmp26_;
		ValaCCodeWriter* _tmp27_;
		ValaCCodeWriter* _tmp28_;
		ValaCCodeFragment* _tmp29_;
		ValaCCodeWriter* _tmp30_;
		ValaCCodeWriter* _tmp31_;
		ValaCCodeFragment* _tmp32_;
		ValaCCodeWriter* _tmp33_;
		ValaCCodeWriter* _tmp34_;
#line 161 "valaccodefile.vala"
		_tmp3_ = writer;
#line 161 "valaccodefile.vala"
		vala_ccode_writer_set_line_directives (_tmp3_, line_directives);
#line 163 "valaccodefile.vala"
		_tmp4_ = self->priv->comments;
#line 163 "valaccodefile.vala"
		_tmp5_ = writer;
#line 163 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp4_, _tmp5_);
#line 164 "valaccodefile.vala"
		_tmp6_ = writer;
#line 164 "valaccodefile.vala"
		vala_ccode_file_write_compiler_compatibility (_tmp6_);
#line 165 "valaccodefile.vala"
		_tmp7_ = writer;
#line 165 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp7_);
#line 166 "valaccodefile.vala"
		_tmp8_ = self->priv->feature_test_macros;
#line 166 "valaccodefile.vala"
		_tmp9_ = writer;
#line 166 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp8_, _tmp9_);
#line 167 "valaccodefile.vala"
		_tmp10_ = writer;
#line 167 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp10_);
#line 168 "valaccodefile.vala"
		_tmp11_ = self->priv->include_directives;
#line 168 "valaccodefile.vala"
		_tmp12_ = writer;
#line 168 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp11_, _tmp12_);
#line 169 "valaccodefile.vala"
		_tmp13_ = writer;
#line 169 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp13_);
#line 170 "valaccodefile.vala"
		_tmp14_ = self->priv->define_directives;
#line 170 "valaccodefile.vala"
		_tmp15_ = writer;
#line 170 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp14_, _tmp15_);
#line 171 "valaccodefile.vala"
		_tmp16_ = writer;
#line 171 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp16_);
#line 172 "valaccodefile.vala"
		_tmp17_ = self->priv->type_declaration;
#line 172 "valaccodefile.vala"
		_tmp18_ = writer;
#line 172 "valaccodefile.vala"
		vala_ccode_node_write_combined ((ValaCCodeNode*) _tmp17_, _tmp18_);
#line 173 "valaccodefile.vala"
		_tmp19_ = writer;
#line 173 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp19_);
#line 174 "valaccodefile.vala"
		_tmp20_ = self->priv->type_definition;
#line 174 "valaccodefile.vala"
		_tmp21_ = writer;
#line 174 "valaccodefile.vala"
		vala_ccode_node_write_combined ((ValaCCodeNode*) _tmp20_, _tmp21_);
#line 175 "valaccodefile.vala"
		_tmp22_ = writer;
#line 175 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp22_);
#line 176 "valaccodefile.vala"
		_tmp23_ = self->priv->type_member_declaration;
#line 176 "valaccodefile.vala"
		_tmp24_ = writer;
#line 176 "valaccodefile.vala"
		vala_ccode_node_write_declaration ((ValaCCodeNode*) _tmp23_, _tmp24_);
#line 177 "valaccodefile.vala"
		_tmp25_ = writer;
#line 177 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp25_);
#line 178 "valaccodefile.vala"
		_tmp26_ = self->priv->type_member_declaration;
#line 178 "valaccodefile.vala"
		_tmp27_ = writer;
#line 178 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp26_, _tmp27_);
#line 179 "valaccodefile.vala"
		_tmp28_ = writer;
#line 179 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp28_);
#line 180 "valaccodefile.vala"
		_tmp29_ = self->priv->constant_declaration;
#line 180 "valaccodefile.vala"
		_tmp30_ = writer;
#line 180 "valaccodefile.vala"
		vala_ccode_node_write_combined ((ValaCCodeNode*) _tmp29_, _tmp30_);
#line 181 "valaccodefile.vala"
		_tmp31_ = writer;
#line 181 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp31_);
#line 182 "valaccodefile.vala"
		_tmp32_ = self->priv->type_member_definition;
#line 182 "valaccodefile.vala"
		_tmp33_ = writer;
#line 182 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp32_, _tmp33_);
#line 183 "valaccodefile.vala"
		_tmp34_ = writer;
#line 183 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp34_);
#line 917 "valaccodefile.c"
	} else {
		ValaCCodeWriter* _tmp35_;
		ValaCCodeOnceSection* once = NULL;
		ValaCCodeWriter* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		ValaCCodeOnceSection* _tmp41_;
		ValaCCodeOnceSection* _tmp42_;
		ValaCCodeOnceSection* _tmp43_;
		ValaCCodeNewline* _tmp44_;
		ValaCCodeNewline* _tmp45_;
		ValaCCodeOnceSection* _tmp46_;
		ValaCCodeFragment* _tmp47_;
		ValaCCodeOnceSection* _tmp48_;
		ValaCCodeNewline* _tmp49_;
		ValaCCodeNewline* _tmp50_;
		ValaCCodeOnceSection* _tmp57_;
		ValaCCodeNewline* _tmp58_;
		ValaCCodeNewline* _tmp59_;
		ValaCCodeOnceSection* _tmp60_;
		ValaCCodeFragment* _tmp61_;
		ValaCCodeOnceSection* _tmp62_;
		ValaCCodeNewline* _tmp63_;
		ValaCCodeNewline* _tmp64_;
		ValaCCodeOnceSection* _tmp65_;
		ValaCCodeFragment* _tmp66_;
		ValaCCodeOnceSection* _tmp67_;
		ValaCCodeNewline* _tmp68_;
		ValaCCodeNewline* _tmp69_;
		ValaCCodeOnceSection* _tmp70_;
		ValaCCodeFragment* _tmp71_;
		ValaCCodeOnceSection* _tmp72_;
		ValaCCodeNewline* _tmp73_;
		ValaCCodeNewline* _tmp74_;
		ValaCCodeOnceSection* _tmp75_;
		ValaCCodeFragment* _tmp76_;
		ValaCCodeOnceSection* _tmp77_;
		ValaCCodeNewline* _tmp78_;
		ValaCCodeNewline* _tmp79_;
		ValaCCodeOnceSection* _tmp80_;
		ValaCCodeFragment* _tmp81_;
		ValaCCodeOnceSection* _tmp82_;
		ValaCCodeNewline* _tmp83_;
		ValaCCodeNewline* _tmp84_;
		ValaCCodeOnceSection* _tmp91_;
		ValaCCodeNewline* _tmp92_;
		ValaCCodeNewline* _tmp93_;
		ValaCCodeOnceSection* _tmp94_;
		ValaCCodeWriter* _tmp95_;
#line 185 "valaccodefile.vala"
		_tmp35_ = writer;
#line 185 "valaccodefile.vala"
		vala_ccode_writer_write_newline (_tmp35_);
#line 187 "valaccodefile.vala"
		_tmp36_ = writer;
#line 187 "valaccodefile.vala"
		_tmp37_ = vala_ccode_writer_get_filename (_tmp36_);
#line 187 "valaccodefile.vala"
		_tmp38_ = _tmp37_;
#line 187 "valaccodefile.vala"
		_tmp39_ = vala_ccode_file_get_define_for_filename (_tmp38_);
#line 187 "valaccodefile.vala"
		_tmp40_ = _tmp39_;
#line 187 "valaccodefile.vala"
		_tmp41_ = vala_ccode_once_section_new (_tmp40_);
#line 187 "valaccodefile.vala"
		_tmp42_ = _tmp41_;
#line 187 "valaccodefile.vala"
		_g_free0 (_tmp40_);
#line 187 "valaccodefile.vala"
		once = _tmp42_;
#line 188 "valaccodefile.vala"
		_tmp43_ = once;
#line 188 "valaccodefile.vala"
		_tmp44_ = vala_ccode_newline_new ();
#line 188 "valaccodefile.vala"
		_tmp45_ = _tmp44_;
#line 188 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp43_, (ValaCCodeNode*) _tmp45_);
#line 188 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp45_);
#line 189 "valaccodefile.vala"
		_tmp46_ = once;
#line 189 "valaccodefile.vala"
		_tmp47_ = self->priv->include_directives;
#line 189 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp46_, (ValaCCodeNode*) _tmp47_);
#line 190 "valaccodefile.vala"
		_tmp48_ = once;
#line 190 "valaccodefile.vala"
		_tmp49_ = vala_ccode_newline_new ();
#line 190 "valaccodefile.vala"
		_tmp50_ = _tmp49_;
#line 190 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp48_, (ValaCCodeNode*) _tmp50_);
#line 190 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp50_);
#line 192 "valaccodefile.vala"
		if (begin_decls != NULL) {
#line 1019 "valaccodefile.c"
			ValaCCodeOnceSection* _tmp51_;
			ValaCCodeIdentifier* _tmp52_;
			ValaCCodeIdentifier* _tmp53_;
			ValaCCodeOnceSection* _tmp54_;
			ValaCCodeNewline* _tmp55_;
			ValaCCodeNewline* _tmp56_;
#line 193 "valaccodefile.vala"
			_tmp51_ = once;
#line 193 "valaccodefile.vala"
			_tmp52_ = vala_ccode_identifier_new (begin_decls);
#line 193 "valaccodefile.vala"
			_tmp53_ = _tmp52_;
#line 193 "valaccodefile.vala"
			vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp51_, (ValaCCodeNode*) _tmp53_);
#line 193 "valaccodefile.vala"
			_vala_ccode_node_unref0 (_tmp53_);
#line 194 "valaccodefile.vala"
			_tmp54_ = once;
#line 194 "valaccodefile.vala"
			_tmp55_ = vala_ccode_newline_new ();
#line 194 "valaccodefile.vala"
			_tmp56_ = _tmp55_;
#line 194 "valaccodefile.vala"
			vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp54_, (ValaCCodeNode*) _tmp56_);
#line 194 "valaccodefile.vala"
			_vala_ccode_node_unref0 (_tmp56_);
#line 1046 "valaccodefile.c"
		}
#line 197 "valaccodefile.vala"
		_tmp57_ = once;
#line 197 "valaccodefile.vala"
		_tmp58_ = vala_ccode_newline_new ();
#line 197 "valaccodefile.vala"
		_tmp59_ = _tmp58_;
#line 197 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp57_, (ValaCCodeNode*) _tmp59_);
#line 197 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp59_);
#line 198 "valaccodefile.vala"
		_tmp60_ = once;
#line 198 "valaccodefile.vala"
		_tmp61_ = self->priv->define_directives;
#line 198 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp60_, (ValaCCodeNode*) _tmp61_);
#line 199 "valaccodefile.vala"
		_tmp62_ = once;
#line 199 "valaccodefile.vala"
		_tmp63_ = vala_ccode_newline_new ();
#line 199 "valaccodefile.vala"
		_tmp64_ = _tmp63_;
#line 199 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp62_, (ValaCCodeNode*) _tmp64_);
#line 199 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp64_);
#line 200 "valaccodefile.vala"
		_tmp65_ = once;
#line 200 "valaccodefile.vala"
		_tmp66_ = self->priv->type_declaration;
#line 200 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp65_, (ValaCCodeNode*) _tmp66_);
#line 201 "valaccodefile.vala"
		_tmp67_ = once;
#line 201 "valaccodefile.vala"
		_tmp68_ = vala_ccode_newline_new ();
#line 201 "valaccodefile.vala"
		_tmp69_ = _tmp68_;
#line 201 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp67_, (ValaCCodeNode*) _tmp69_);
#line 201 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp69_);
#line 202 "valaccodefile.vala"
		_tmp70_ = once;
#line 202 "valaccodefile.vala"
		_tmp71_ = self->priv->type_definition;
#line 202 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp70_, (ValaCCodeNode*) _tmp71_);
#line 203 "valaccodefile.vala"
		_tmp72_ = once;
#line 203 "valaccodefile.vala"
		_tmp73_ = vala_ccode_newline_new ();
#line 203 "valaccodefile.vala"
		_tmp74_ = _tmp73_;
#line 203 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp72_, (ValaCCodeNode*) _tmp74_);
#line 203 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp74_);
#line 204 "valaccodefile.vala"
		_tmp75_ = once;
#line 204 "valaccodefile.vala"
		_tmp76_ = self->priv->type_member_declaration;
#line 204 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp75_, (ValaCCodeNode*) _tmp76_);
#line 205 "valaccodefile.vala"
		_tmp77_ = once;
#line 205 "valaccodefile.vala"
		_tmp78_ = vala_ccode_newline_new ();
#line 205 "valaccodefile.vala"
		_tmp79_ = _tmp78_;
#line 205 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp77_, (ValaCCodeNode*) _tmp79_);
#line 205 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp79_);
#line 206 "valaccodefile.vala"
		_tmp80_ = once;
#line 206 "valaccodefile.vala"
		_tmp81_ = self->priv->constant_declaration;
#line 206 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp80_, (ValaCCodeNode*) _tmp81_);
#line 207 "valaccodefile.vala"
		_tmp82_ = once;
#line 207 "valaccodefile.vala"
		_tmp83_ = vala_ccode_newline_new ();
#line 207 "valaccodefile.vala"
		_tmp84_ = _tmp83_;
#line 207 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp82_, (ValaCCodeNode*) _tmp84_);
#line 207 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp84_);
#line 209 "valaccodefile.vala"
		if (end_decls != NULL) {
#line 1140 "valaccodefile.c"
			ValaCCodeOnceSection* _tmp85_;
			ValaCCodeIdentifier* _tmp86_;
			ValaCCodeIdentifier* _tmp87_;
			ValaCCodeOnceSection* _tmp88_;
			ValaCCodeNewline* _tmp89_;
			ValaCCodeNewline* _tmp90_;
#line 210 "valaccodefile.vala"
			_tmp85_ = once;
#line 210 "valaccodefile.vala"
			_tmp86_ = vala_ccode_identifier_new (end_decls);
#line 210 "valaccodefile.vala"
			_tmp87_ = _tmp86_;
#line 210 "valaccodefile.vala"
			vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp85_, (ValaCCodeNode*) _tmp87_);
#line 210 "valaccodefile.vala"
			_vala_ccode_node_unref0 (_tmp87_);
#line 211 "valaccodefile.vala"
			_tmp88_ = once;
#line 211 "valaccodefile.vala"
			_tmp89_ = vala_ccode_newline_new ();
#line 211 "valaccodefile.vala"
			_tmp90_ = _tmp89_;
#line 211 "valaccodefile.vala"
			vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp88_, (ValaCCodeNode*) _tmp90_);
#line 211 "valaccodefile.vala"
			_vala_ccode_node_unref0 (_tmp90_);
#line 1167 "valaccodefile.c"
		}
#line 214 "valaccodefile.vala"
		_tmp91_ = once;
#line 214 "valaccodefile.vala"
		_tmp92_ = vala_ccode_newline_new ();
#line 214 "valaccodefile.vala"
		_tmp93_ = _tmp92_;
#line 214 "valaccodefile.vala"
		vala_ccode_fragment_append ((ValaCCodeFragment*) _tmp91_, (ValaCCodeNode*) _tmp93_);
#line 214 "valaccodefile.vala"
		_vala_ccode_node_unref0 (_tmp93_);
#line 215 "valaccodefile.vala"
		_tmp94_ = once;
#line 215 "valaccodefile.vala"
		_tmp95_ = writer;
#line 215 "valaccodefile.vala"
		vala_ccode_node_write ((ValaCCodeNode*) _tmp94_, _tmp95_);
#line 160 "valaccodefile.vala"
		_vala_ccode_node_unref0 (once);
#line 1187 "valaccodefile.c"
	}
#line 218 "valaccodefile.vala"
	_tmp96_ = writer;
#line 218 "valaccodefile.vala"
	vala_ccode_writer_close (_tmp96_);
#line 220 "valaccodefile.vala"
	result = TRUE;
#line 220 "valaccodefile.vala"
	_vala_ccode_writer_unref0 (writer);
#line 220 "valaccodefile.vala"
	return result;
#line 1199 "valaccodefile.c"
}

static void
vala_ccode_file_write_compiler_compatibility (ValaCCodeWriter* writer)
{
#line 223 "valaccodefile.vala"
	g_return_if_fail (writer != NULL);
#line 224 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, "#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14");
#line 225 "valaccodefile.vala"
	vala_ccode_writer_write_newline (writer);
#line 226 "valaccodefile.vala"
	vala_ccode_file_write_compiler_compatibility_pragma_warning (writer, "GCC", "-Wimplicit-function-declaration");
#line 227 "valaccodefile.vala"
	vala_ccode_file_write_compiler_compatibility_pragma_warning (writer, "GCC", "-Wincompatible-pointer-types");
#line 228 "valaccodefile.vala"
	vala_ccode_file_write_compiler_compatibility_pragma_warning (writer, "GCC", "-Wint-conversion");
#line 229 "valaccodefile.vala"
	vala_ccode_file_write_compiler_compatibility_pragma_warning (writer, "GCC", "-Wreturn-mismatch");
#line 230 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, "#endif");
#line 231 "valaccodefile.vala"
	vala_ccode_writer_write_newline (writer);
#line 1223 "valaccodefile.c"
}

static void
vala_ccode_file_write_compiler_compatibility_pragma_warning (ValaCCodeWriter* writer,
                                                             const gchar* compiler,
                                                             const gchar* warning)
{
#line 234 "valaccodefile.vala"
	g_return_if_fail (writer != NULL);
#line 234 "valaccodefile.vala"
	g_return_if_fail (compiler != NULL);
#line 234 "valaccodefile.vala"
	g_return_if_fail (warning != NULL);
#line 235 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, "#pragma ");
#line 236 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, compiler);
#line 237 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, " diagnostic warning \"");
#line 238 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, warning);
#line 239 "valaccodefile.vala"
	vala_ccode_writer_write_string (writer, "\"");
#line 240 "valaccodefile.vala"
	vala_ccode_writer_write_newline (writer);
#line 1249 "valaccodefile.c"
}

static void
vala_value_ccode_file_init (GValue* value)
{
#line 24 "valaccodefile.vala"
	value->data[0].v_pointer = NULL;
#line 1257 "valaccodefile.c"
}

static void
vala_value_ccode_file_free_value (GValue* value)
{
#line 24 "valaccodefile.vala"
	if (value->data[0].v_pointer) {
#line 24 "valaccodefile.vala"
		vala_ccode_file_unref (value->data[0].v_pointer);
#line 1267 "valaccodefile.c"
	}
}

static void
vala_value_ccode_file_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 24 "valaccodefile.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "valaccodefile.vala"
		dest_value->data[0].v_pointer = vala_ccode_file_ref (src_value->data[0].v_pointer);
#line 1279 "valaccodefile.c"
	} else {
#line 24 "valaccodefile.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1283 "valaccodefile.c"
	}
}

static gpointer
vala_value_ccode_file_peek_pointer (const GValue* value)
{
#line 24 "valaccodefile.vala"
	return value->data[0].v_pointer;
#line 1292 "valaccodefile.c"
}

static gchar*
vala_value_ccode_file_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 24 "valaccodefile.vala"
	if (collect_values[0].v_pointer) {
#line 1303 "valaccodefile.c"
		ValaCCodeFile * object;
		object = collect_values[0].v_pointer;
#line 24 "valaccodefile.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "valaccodefile.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1310 "valaccodefile.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "valaccodefile.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1314 "valaccodefile.c"
		}
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = vala_ccode_file_ref (object);
#line 1318 "valaccodefile.c"
	} else {
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = NULL;
#line 1322 "valaccodefile.c"
	}
#line 24 "valaccodefile.vala"
	return NULL;
#line 1326 "valaccodefile.c"
}

static gchar*
vala_value_ccode_file_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	ValaCCodeFile ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "valaccodefile.vala"
	if (!object_p) {
#line 24 "valaccodefile.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1341 "valaccodefile.c"
	}
#line 24 "valaccodefile.vala"
	if (!value->data[0].v_pointer) {
#line 24 "valaccodefile.vala"
		*object_p = NULL;
#line 1347 "valaccodefile.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "valaccodefile.vala"
		*object_p = value->data[0].v_pointer;
#line 1351 "valaccodefile.c"
	} else {
#line 24 "valaccodefile.vala"
		*object_p = vala_ccode_file_ref (value->data[0].v_pointer);
#line 1355 "valaccodefile.c"
	}
#line 24 "valaccodefile.vala"
	return NULL;
#line 1359 "valaccodefile.c"
}

GParamSpec*
vala_param_spec_ccode_file (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ValaParamSpecCCodeFile* spec;
#line 24 "valaccodefile.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VALA_TYPE_CCODE_FILE), NULL);
#line 24 "valaccodefile.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "valaccodefile.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "valaccodefile.vala"
	return G_PARAM_SPEC (spec);
#line 1378 "valaccodefile.c"
}

gpointer
vala_value_get_ccode_file (const GValue* value)
{
#line 24 "valaccodefile.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_FILE), NULL);
#line 24 "valaccodefile.vala"
	return value->data[0].v_pointer;
#line 1388 "valaccodefile.c"
}

void
vala_value_set_ccode_file (GValue* value,
                           gpointer v_object)
{
	ValaCCodeFile * old;
#line 24 "valaccodefile.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_FILE));
#line 24 "valaccodefile.vala"
	old = value->data[0].v_pointer;
#line 24 "valaccodefile.vala"
	if (v_object) {
#line 24 "valaccodefile.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_FILE));
#line 24 "valaccodefile.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = v_object;
#line 24 "valaccodefile.vala"
		vala_ccode_file_ref (value->data[0].v_pointer);
#line 1410 "valaccodefile.c"
	} else {
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = NULL;
#line 1414 "valaccodefile.c"
	}
#line 24 "valaccodefile.vala"
	if (old) {
#line 24 "valaccodefile.vala"
		vala_ccode_file_unref (old);
#line 1420 "valaccodefile.c"
	}
}

void
vala_value_take_ccode_file (GValue* value,
                            gpointer v_object)
{
	ValaCCodeFile * old;
#line 24 "valaccodefile.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_FILE));
#line 24 "valaccodefile.vala"
	old = value->data[0].v_pointer;
#line 24 "valaccodefile.vala"
	if (v_object) {
#line 24 "valaccodefile.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_FILE));
#line 24 "valaccodefile.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = v_object;
#line 1441 "valaccodefile.c"
	} else {
#line 24 "valaccodefile.vala"
		value->data[0].v_pointer = NULL;
#line 1445 "valaccodefile.c"
	}
#line 24 "valaccodefile.vala"
	if (old) {
#line 24 "valaccodefile.vala"
		vala_ccode_file_unref (old);
#line 1451 "valaccodefile.c"
	}
}

static void
vala_ccode_file_class_init (ValaCCodeFileClass * klass,
                            gpointer klass_data)
{
#line 24 "valaccodefile.vala"
	vala_ccode_file_parent_class = g_type_class_peek_parent (klass);
#line 24 "valaccodefile.vala"
	((ValaCCodeFileClass *) klass)->finalize = vala_ccode_file_finalize;
#line 24 "valaccodefile.vala"
	g_type_class_adjust_private_offset (klass, &ValaCCodeFile_private_offset);
#line 1465 "valaccodefile.c"
}

static void
vala_ccode_file_instance_init (ValaCCodeFile * self,
                               gpointer klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	ValaHashSet* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	ValaHashSet* _tmp5_;
	GHashFunc _tmp6_;
	GEqualFunc _tmp7_;
	ValaHashSet* _tmp8_;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	ValaHashSet* _tmp11_;
	ValaCCodeFragment* _tmp12_;
	ValaCCodeFragment* _tmp13_;
	ValaCCodeFragment* _tmp14_;
	ValaCCodeFragment* _tmp15_;
	ValaCCodeFragment* _tmp16_;
	ValaCCodeFragment* _tmp17_;
	ValaCCodeFragment* _tmp18_;
	ValaCCodeFragment* _tmp19_;
	ValaCCodeFragment* _tmp20_;
#line 24 "valaccodefile.vala"
	self->priv = vala_ccode_file_get_instance_private (self);
#line 29 "valaccodefile.vala"
	_tmp0_ = g_str_hash;
#line 29 "valaccodefile.vala"
	_tmp1_ = g_str_equal;
#line 29 "valaccodefile.vala"
	_tmp2_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp0_, _tmp1_);
#line 29 "valaccodefile.vala"
	self->priv->features = (ValaSet*) _tmp2_;
#line 30 "valaccodefile.vala"
	_tmp3_ = g_str_hash;
#line 30 "valaccodefile.vala"
	_tmp4_ = g_str_equal;
#line 30 "valaccodefile.vala"
	_tmp5_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp3_, _tmp4_);
#line 30 "valaccodefile.vala"
	self->priv->declarations = (ValaSet*) _tmp5_;
#line 31 "valaccodefile.vala"
	_tmp6_ = g_str_hash;
#line 31 "valaccodefile.vala"
	_tmp7_ = g_str_equal;
#line 31 "valaccodefile.vala"
	_tmp8_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp6_, _tmp7_);
#line 31 "valaccodefile.vala"
	self->priv->definitions = (ValaSet*) _tmp8_;
#line 32 "valaccodefile.vala"
	_tmp9_ = g_str_hash;
#line 32 "valaccodefile.vala"
	_tmp10_ = g_str_equal;
#line 32 "valaccodefile.vala"
	_tmp11_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp9_, _tmp10_);
#line 32 "valaccodefile.vala"
	self->priv->includes = (ValaSet*) _tmp11_;
#line 33 "valaccodefile.vala"
	_tmp12_ = vala_ccode_fragment_new ();
#line 33 "valaccodefile.vala"
	self->priv->comments = _tmp12_;
#line 34 "valaccodefile.vala"
	_tmp13_ = vala_ccode_fragment_new ();
#line 34 "valaccodefile.vala"
	self->priv->feature_test_macros = _tmp13_;
#line 35 "valaccodefile.vala"
	_tmp14_ = vala_ccode_fragment_new ();
#line 35 "valaccodefile.vala"
	self->priv->define_directives = _tmp14_;
#line 36 "valaccodefile.vala"
	_tmp15_ = vala_ccode_fragment_new ();
#line 36 "valaccodefile.vala"
	self->priv->include_directives = _tmp15_;
#line 37 "valaccodefile.vala"
	_tmp16_ = vala_ccode_fragment_new ();
#line 37 "valaccodefile.vala"
	self->priv->type_declaration = _tmp16_;
#line 38 "valaccodefile.vala"
	_tmp17_ = vala_ccode_fragment_new ();
#line 38 "valaccodefile.vala"
	self->priv->type_definition = _tmp17_;
#line 39 "valaccodefile.vala"
	_tmp18_ = vala_ccode_fragment_new ();
#line 39 "valaccodefile.vala"
	self->priv->type_member_declaration = _tmp18_;
#line 40 "valaccodefile.vala"
	_tmp19_ = vala_ccode_fragment_new ();
#line 40 "valaccodefile.vala"
	self->priv->constant_declaration = _tmp19_;
#line 41 "valaccodefile.vala"
	_tmp20_ = vala_ccode_fragment_new ();
#line 41 "valaccodefile.vala"
	self->priv->type_member_definition = _tmp20_;
#line 24 "valaccodefile.vala"
	self->ref_count = 1;
#line 1565 "valaccodefile.c"
}

static void
vala_ccode_file_finalize (ValaCCodeFile * obj)
{
	ValaCCodeFile * self;
#line 24 "valaccodefile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_FILE, ValaCCodeFile);
#line 24 "valaccodefile.vala"
	g_signal_handlers_destroy (self);
#line 29 "valaccodefile.vala"
	_vala_iterable_unref0 (self->priv->features);
#line 30 "valaccodefile.vala"
	_vala_iterable_unref0 (self->priv->declarations);
#line 31 "valaccodefile.vala"
	_vala_iterable_unref0 (self->priv->definitions);
#line 32 "valaccodefile.vala"
	_vala_iterable_unref0 (self->priv->includes);
#line 33 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->comments);
#line 34 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->feature_test_macros);
#line 35 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->define_directives);
#line 36 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->include_directives);
#line 37 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->type_declaration);
#line 38 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->type_definition);
#line 39 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->type_member_declaration);
#line 40 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->constant_declaration);
#line 41 "valaccodefile.vala"
	_vala_ccode_node_unref0 (self->priv->type_member_definition);
#line 1602 "valaccodefile.c"
}

static GType
vala_ccode_file_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { vala_value_ccode_file_init, vala_value_ccode_file_free_value, vala_value_ccode_file_copy_value, vala_value_ccode_file_peek_pointer, "p", vala_value_ccode_file_collect_value, "p", vala_value_ccode_file_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeFile), 0, (GInstanceInitFunc) vala_ccode_file_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType vala_ccode_file_type_id;
	vala_ccode_file_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValaCCodeFile", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ValaCCodeFile_private_offset = g_type_add_instance_private (vala_ccode_file_type_id, sizeof (ValaCCodeFilePrivate));
	return vala_ccode_file_type_id;
}

GType
vala_ccode_file_get_type (void)
{
	static volatile gsize vala_ccode_file_type_id__once = 0;
	if (g_once_init_enter (&vala_ccode_file_type_id__once)) {
		GType vala_ccode_file_type_id;
		vala_ccode_file_type_id = vala_ccode_file_get_type_once ();
		g_once_init_leave (&vala_ccode_file_type_id__once, vala_ccode_file_type_id);
	}
	return vala_ccode_file_type_id__once;
}

gpointer
vala_ccode_file_ref (gpointer instance)
{
	ValaCCodeFile * self;
	self = instance;
#line 24 "valaccodefile.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "valaccodefile.vala"
	return instance;
#line 1638 "valaccodefile.c"
}

void
vala_ccode_file_unref (gpointer instance)
{
	ValaCCodeFile * self;
	self = instance;
#line 24 "valaccodefile.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "valaccodefile.vala"
		VALA_CCODE_FILE_GET_CLASS (self)->finalize (self);
#line 24 "valaccodefile.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1652 "valaccodefile.c"
	}
}

static GType
ccode_file_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{CCODE_FILE_TYPE_SOURCE, "CCODE_FILE_TYPE_SOURCE", "source"}, {CCODE_FILE_TYPE_PUBLIC_HEADER, "CCODE_FILE_TYPE_PUBLIC_HEADER", "public-header"}, {CCODE_FILE_TYPE_INTERNAL_HEADER, "CCODE_FILE_TYPE_INTERNAL_HEADER", "internal-header"}, {CCODE_FILE_TYPE_HEADER, "CCODE_FILE_TYPE_HEADER", "header"}, {0, NULL, NULL}};
	GType ccode_file_type_type_id;
	ccode_file_type_type_id = g_flags_register_static ("CCodeFileType", values);
	return ccode_file_type_type_id;
}

GType
ccode_file_type_get_type (void)
{
	static volatile gsize ccode_file_type_type_id__once = 0;
	if (g_once_init_enter (&ccode_file_type_type_id__once)) {
		GType ccode_file_type_type_id;
		ccode_file_type_type_id = ccode_file_type_get_type_once ();
		g_once_init_leave (&ccode_file_type_type_id__once, ccode_file_type_type_id);
	}
	return ccode_file_type_type_id__once;
}

