/* valaccodewriter.c generated by valac, the Vala compiler
 * generated from valaccodewriter.vala, do not modify */

/* valaccodewriter.vala
 *
 * Copyright (C) 2006-2009  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "valaccode.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include <vala.h>
#include <sys/types.h>
#include <utime.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _ValaParamSpecCCodeWriter ValaParamSpecCCodeWriter;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ValaCCodeWriterPrivate {
	gchar* _filename;
	gchar* source_filename;
	gboolean _line_directives;
	gchar* temp_filename;
	gboolean file_exists;
	FILE* stream;
	gint indent;
	gint current_line_number;
	gboolean using_line_directive;
	gboolean _bol;
	gboolean _bael;
};

struct _ValaParamSpecCCodeWriter {
	GParamSpec parent_instance;
};

static gint ValaCCodeWriter_private_offset;
static gpointer vala_ccode_writer_parent_class = NULL;
static GRegex* vala_ccode_writer_fix_indent_regex;
static GRegex* vala_ccode_writer_fix_indent_regex = NULL;

static void vala_ccode_writer_finalize (ValaCCodeWriter * obj);
static GType vala_ccode_writer_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
vala_ccode_writer_get_instance_private (ValaCCodeWriter* self)
{
	return G_STRUCT_MEMBER_P (self, ValaCCodeWriter_private_offset);
}

const gchar*
vala_ccode_writer_get_filename (ValaCCodeWriter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "valaccodewriter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "valaccodewriter.vala"
	_tmp0_ = self->priv->_filename;
#line 32 "valaccodewriter.vala"
	result = _tmp0_;
#line 32 "valaccodewriter.vala"
	return result;
#line 107 "valaccodewriter.c"
}

void
vala_ccode_writer_set_filename (ValaCCodeWriter* self,
                                const gchar* value)
{
	gchar* _tmp0_;
#line 32 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 32 "valaccodewriter.vala"
	_tmp0_ = g_strdup (value);
#line 32 "valaccodewriter.vala"
	_g_free0 (self->priv->_filename);
#line 32 "valaccodewriter.vala"
	self->priv->_filename = _tmp0_;
#line 123 "valaccodewriter.c"
}

gboolean
vala_ccode_writer_get_line_directives (ValaCCodeWriter* self)
{
	gboolean result;
#line 42 "valaccodewriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "valaccodewriter.vala"
	result = self->priv->_line_directives;
#line 42 "valaccodewriter.vala"
	return result;
#line 136 "valaccodewriter.c"
}

void
vala_ccode_writer_set_line_directives (ValaCCodeWriter* self,
                                       gboolean value)
{
#line 42 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 42 "valaccodewriter.vala"
	self->priv->_line_directives = value;
#line 147 "valaccodewriter.c"
}

gboolean
vala_ccode_writer_get_bol (ValaCCodeWriter* self)
{
	gboolean result;
#line 48 "valaccodewriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "valaccodewriter.vala"
	result = self->priv->_bol;
#line 48 "valaccodewriter.vala"
	return result;
#line 160 "valaccodewriter.c"
}

ValaCCodeWriter*
vala_ccode_writer_construct (GType object_type,
                             const gchar* filename,
                             const gchar* source_filename)
{
	ValaCCodeWriter* self = NULL;
	gchar* _tmp0_;
#line 67 "valaccodewriter.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 67 "valaccodewriter.vala"
	self = (ValaCCodeWriter*) g_type_create_instance (object_type);
#line 68 "valaccodewriter.vala"
	vala_ccode_writer_set_filename (self, filename);
#line 69 "valaccodewriter.vala"
	_tmp0_ = g_strdup (source_filename);
#line 69 "valaccodewriter.vala"
	_g_free0 (self->priv->source_filename);
#line 69 "valaccodewriter.vala"
	self->priv->source_filename = _tmp0_;
#line 67 "valaccodewriter.vala"
	return self;
#line 184 "valaccodewriter.c"
}

ValaCCodeWriter*
vala_ccode_writer_new (const gchar* filename,
                       const gchar* source_filename)
{
#line 67 "valaccodewriter.vala"
	return vala_ccode_writer_construct (VALA_TYPE_CCODE_WRITER, filename, source_filename);
#line 193 "valaccodewriter.c"
}

/**
 * Opens the file.
 *
 * @return true if the file has been opened successfully,
 *         false otherwise
 */
gboolean
vala_ccode_writer_open (ValaCCodeWriter* self,
                        gboolean write_version)
{
	const gchar* _tmp0_;
	FILE* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* opening = NULL;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gboolean result;
#line 78 "valaccodewriter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "valaccodewriter.vala"
	_tmp0_ = self->priv->_filename;
#line 79 "valaccodewriter.vala"
	self->priv->file_exists = g_file_test (_tmp0_, G_FILE_TEST_EXISTS);
#line 80 "valaccodewriter.vala"
	if (self->priv->file_exists) {
#line 222 "valaccodewriter.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		FILE* _tmp4_;
#line 81 "valaccodewriter.vala"
		_tmp1_ = self->priv->_filename;
#line 81 "valaccodewriter.vala"
		_tmp2_ = g_strdup_printf ("%s.valatmp", _tmp1_);
#line 81 "valaccodewriter.vala"
		_g_free0 (self->priv->temp_filename);
#line 81 "valaccodewriter.vala"
		self->priv->temp_filename = _tmp2_;
#line 82 "valaccodewriter.vala"
		_tmp3_ = self->priv->temp_filename;
#line 82 "valaccodewriter.vala"
		_tmp4_ = g_fopen (_tmp3_, "w");
#line 82 "valaccodewriter.vala"
		_fclose0 (self->priv->stream);
#line 82 "valaccodewriter.vala"
		self->priv->stream = _tmp4_;
#line 243 "valaccodewriter.c"
	} else {
		gchar* dirname = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		FILE* _tmp9_;
#line 88 "valaccodewriter.vala"
		_tmp5_ = self->priv->_filename;
#line 88 "valaccodewriter.vala"
		_tmp6_ = g_path_get_dirname (_tmp5_);
#line 88 "valaccodewriter.vala"
		dirname = _tmp6_;
#line 89 "valaccodewriter.vala"
		_tmp7_ = dirname;
#line 89 "valaccodewriter.vala"
		g_mkdir_with_parents (_tmp7_, 0755);
#line 90 "valaccodewriter.vala"
		_tmp8_ = self->priv->_filename;
#line 90 "valaccodewriter.vala"
		_tmp9_ = g_fopen (_tmp8_, "w");
#line 90 "valaccodewriter.vala"
		_fclose0 (self->priv->stream);
#line 90 "valaccodewriter.vala"
		self->priv->stream = _tmp9_;
#line 80 "valaccodewriter.vala"
		_g_free0 (dirname);
#line 271 "valaccodewriter.c"
	}
#line 93 "valaccodewriter.vala"
	_tmp10_ = self->priv->stream;
#line 93 "valaccodewriter.vala"
	if (_tmp10_ == NULL) {
#line 94 "valaccodewriter.vala"
		result = FALSE;
#line 94 "valaccodewriter.vala"
		return result;
#line 281 "valaccodewriter.c"
	}
#line 97 "valaccodewriter.vala"
	if (write_version) {
#line 285 "valaccodewriter.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 98 "valaccodewriter.vala"
		_tmp12_ = self->priv->_filename;
#line 98 "valaccodewriter.vala"
		_tmp13_ = g_path_get_basename (_tmp12_);
#line 98 "valaccodewriter.vala"
		_tmp14_ = _tmp13_;
#line 98 "valaccodewriter.vala"
		_tmp15_ = g_strdup_printf ("/* %s generated by valac %s, the Vala compiler", _tmp14_, VALA_BUILD_VERSION);
#line 98 "valaccodewriter.vala"
		_g_free0 (_tmp11_);
#line 98 "valaccodewriter.vala"
		_tmp11_ = _tmp15_;
#line 98 "valaccodewriter.vala"
		_g_free0 (_tmp14_);
#line 304 "valaccodewriter.c"
	} else {
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 99 "valaccodewriter.vala"
		_tmp16_ = self->priv->_filename;
#line 99 "valaccodewriter.vala"
		_tmp17_ = g_path_get_basename (_tmp16_);
#line 99 "valaccodewriter.vala"
		_tmp18_ = _tmp17_;
#line 99 "valaccodewriter.vala"
		_tmp19_ = g_strdup_printf ("/* %s generated by valac, the Vala compiler", _tmp18_);
#line 99 "valaccodewriter.vala"
		_g_free0 (_tmp11_);
#line 99 "valaccodewriter.vala"
		_tmp11_ = _tmp19_;
#line 99 "valaccodewriter.vala"
		_g_free0 (_tmp18_);
#line 324 "valaccodewriter.c"
	}
#line 97 "valaccodewriter.vala"
	_tmp20_ = g_strdup (_tmp11_);
#line 97 "valaccodewriter.vala"
	opening = _tmp20_;
#line 100 "valaccodewriter.vala"
	_tmp21_ = opening;
#line 100 "valaccodewriter.vala"
	vala_ccode_writer_write_string (self, _tmp21_);
#line 103 "valaccodewriter.vala"
	_tmp22_ = self->priv->source_filename;
#line 103 "valaccodewriter.vala"
	if (_tmp22_ != NULL) {
#line 338 "valaccodewriter.c"
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 104 "valaccodewriter.vala"
		vala_ccode_writer_write_newline (self);
#line 105 "valaccodewriter.vala"
		_tmp23_ = self->priv->source_filename;
#line 105 "valaccodewriter.vala"
		_tmp24_ = g_path_get_basename (_tmp23_);
#line 105 "valaccodewriter.vala"
		_tmp25_ = _tmp24_;
#line 105 "valaccodewriter.vala"
		_tmp26_ = g_strdup_printf (" * generated from %s", _tmp25_);
#line 105 "valaccodewriter.vala"
		_tmp27_ = _tmp26_;
#line 105 "valaccodewriter.vala"
		vala_ccode_writer_write_string (self, _tmp27_);
#line 105 "valaccodewriter.vala"
		_g_free0 (_tmp27_);
#line 105 "valaccodewriter.vala"
		_g_free0 (_tmp25_);
#line 362 "valaccodewriter.c"
	}
#line 108 "valaccodewriter.vala"
	vala_ccode_writer_write_string (self, ", do not modify */");
#line 109 "valaccodewriter.vala"
	vala_ccode_writer_write_newline (self);
#line 110 "valaccodewriter.vala"
	vala_ccode_writer_write_newline (self);
#line 112 "valaccodewriter.vala"
	result = TRUE;
#line 112 "valaccodewriter.vala"
	_g_free0 (opening);
#line 112 "valaccodewriter.vala"
	_g_free0 (_tmp11_);
#line 112 "valaccodewriter.vala"
	return result;
#line 378 "valaccodewriter.c"
}

/**
 * Closes the file.
 */
void
vala_ccode_writer_close (ValaCCodeWriter* self)
{
	GError* _inner_error0_ = NULL;
#line 118 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 119 "valaccodewriter.vala"
	_fclose0 (self->priv->stream);
#line 119 "valaccodewriter.vala"
	self->priv->stream = NULL;
#line 121 "valaccodewriter.vala"
	if (self->priv->file_exists) {
#line 396 "valaccodewriter.c"
		gboolean changed = FALSE;
#line 122 "valaccodewriter.vala"
		changed = TRUE;
#line 400 "valaccodewriter.c"
		{
			GMappedFile* old_file = NULL;
			const gchar* _tmp0_;
			GMappedFile* _tmp1_;
			GMappedFile* new_file = NULL;
			const gchar* _tmp2_;
			GMappedFile* _tmp3_;
			gsize len = 0UL;
			GMappedFile* _tmp4_;
			GMappedFile* _tmp5_;
#line 125 "valaccodewriter.vala"
			_tmp0_ = self->priv->_filename;
#line 125 "valaccodewriter.vala"
			_tmp1_ = g_mapped_file_new (_tmp0_, FALSE, &_inner_error0_);
#line 125 "valaccodewriter.vala"
			old_file = _tmp1_;
#line 125 "valaccodewriter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "valaccodewriter.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 421 "valaccodewriter.c"
					goto __catch0_g_file_error;
				}
#line 125 "valaccodewriter.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "valaccodewriter.vala"
				g_clear_error (&_inner_error0_);
#line 125 "valaccodewriter.vala"
				return;
#line 430 "valaccodewriter.c"
			}
#line 126 "valaccodewriter.vala"
			_tmp2_ = self->priv->temp_filename;
#line 126 "valaccodewriter.vala"
			_tmp3_ = g_mapped_file_new (_tmp2_, FALSE, &_inner_error0_);
#line 126 "valaccodewriter.vala"
			new_file = _tmp3_;
#line 126 "valaccodewriter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "valaccodewriter.vala"
				_g_mapped_file_unref0 (old_file);
#line 126 "valaccodewriter.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 444 "valaccodewriter.c"
					goto __catch0_g_file_error;
				}
#line 126 "valaccodewriter.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "valaccodewriter.vala"
				g_clear_error (&_inner_error0_);
#line 126 "valaccodewriter.vala"
				return;
#line 453 "valaccodewriter.c"
			}
#line 127 "valaccodewriter.vala"
			_tmp4_ = old_file;
#line 127 "valaccodewriter.vala"
			len = g_mapped_file_get_length (_tmp4_);
#line 128 "valaccodewriter.vala"
			_tmp5_ = new_file;
#line 128 "valaccodewriter.vala"
			if (len == g_mapped_file_get_length (_tmp5_)) {
#line 463 "valaccodewriter.c"
				GMappedFile* _tmp6_;
				gchar* _tmp7_;
				GMappedFile* _tmp8_;
				gchar* _tmp9_;
#line 129 "valaccodewriter.vala"
				_tmp6_ = old_file;
#line 129 "valaccodewriter.vala"
				_tmp7_ = g_mapped_file_get_contents (_tmp6_);
#line 129 "valaccodewriter.vala"
				_tmp8_ = new_file;
#line 129 "valaccodewriter.vala"
				_tmp9_ = g_mapped_file_get_contents (_tmp8_);
#line 129 "valaccodewriter.vala"
				if (memcmp (_tmp7_, _tmp9_, len) == 0) {
#line 130 "valaccodewriter.vala"
					changed = FALSE;
#line 480 "valaccodewriter.c"
				}
			}
#line 133 "valaccodewriter.vala"
			_g_mapped_file_unref0 (old_file);
#line 133 "valaccodewriter.vala"
			old_file = NULL;
#line 134 "valaccodewriter.vala"
			_g_mapped_file_unref0 (new_file);
#line 134 "valaccodewriter.vala"
			new_file = NULL;
#line 124 "valaccodewriter.vala"
			_g_mapped_file_unref0 (new_file);
#line 124 "valaccodewriter.vala"
			_g_mapped_file_unref0 (old_file);
#line 495 "valaccodewriter.c"
		}
		goto __finally0;
		__catch0_g_file_error:
		{
#line 124 "valaccodewriter.vala"
			g_clear_error (&_inner_error0_);
#line 502 "valaccodewriter.c"
		}
		__finally0:
#line 124 "valaccodewriter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "valaccodewriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "valaccodewriter.vala"
			g_clear_error (&_inner_error0_);
#line 124 "valaccodewriter.vala"
			return;
#line 513 "valaccodewriter.c"
		}
#line 139 "valaccodewriter.vala"
		if (changed) {
#line 517 "valaccodewriter.c"
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 140 "valaccodewriter.vala"
			_tmp10_ = self->priv->temp_filename;
#line 140 "valaccodewriter.vala"
			_tmp11_ = self->priv->_filename;
#line 140 "valaccodewriter.vala"
			g_rename (_tmp10_, _tmp11_);
#line 526 "valaccodewriter.c"
		} else {
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 142 "valaccodewriter.vala"
			_tmp12_ = self->priv->temp_filename;
#line 142 "valaccodewriter.vala"
			g_unlink (_tmp12_);
#line 143 "valaccodewriter.vala"
			_tmp13_ = self->priv->source_filename;
#line 143 "valaccodewriter.vala"
			if (_tmp13_ != NULL) {
#line 538 "valaccodewriter.c"
				GStatBuf stats = {0};
				const gchar* _tmp14_;
				GStatBuf target_stats = {0};
				const gchar* _tmp15_;
				GStatBuf _tmp16_;
				GStatBuf _tmp17_;
#line 144 "valaccodewriter.vala"
				_tmp14_ = self->priv->source_filename;
#line 144 "valaccodewriter.vala"
				g_stat (_tmp14_, &stats);
#line 145 "valaccodewriter.vala"
				_tmp15_ = self->priv->_filename;
#line 145 "valaccodewriter.vala"
				g_stat (_tmp15_, &target_stats);
#line 146 "valaccodewriter.vala"
				_tmp16_ = stats;
#line 146 "valaccodewriter.vala"
				_tmp17_ = target_stats;
#line 146 "valaccodewriter.vala"
				if (_tmp16_.st_mtime >= _tmp17_.st_mtime) {
#line 559 "valaccodewriter.c"
					struct utimbuf timebuf = {0};
					GStatBuf _tmp18_;
					GStatBuf _tmp19_;
					struct utimbuf _tmp20_ = {0};
					const gchar* _tmp21_;
					struct utimbuf _tmp22_;
#line 147 "valaccodewriter.vala"
					_tmp18_ = stats;
#line 147 "valaccodewriter.vala"
					_tmp19_ = stats;
#line 147 "valaccodewriter.vala"
					_tmp20_.actime = _tmp18_.st_atime + 1;
#line 147 "valaccodewriter.vala"
					_tmp20_.modtime = _tmp19_.st_mtime + 1;
#line 147 "valaccodewriter.vala"
					timebuf = _tmp20_;
#line 148 "valaccodewriter.vala"
					_tmp21_ = self->priv->_filename;
#line 148 "valaccodewriter.vala"
					_tmp22_ = timebuf;
#line 148 "valaccodewriter.vala"
					g_utime (_tmp21_, &_tmp22_);
#line 582 "valaccodewriter.c"
				}
			}
		}
	}
}

/**
 * Writes tabs according to the current indent level.
 */
void
vala_ccode_writer_write_indent (ValaCCodeWriter* self,
                                ValaCCodeLineDirective* line)
{
	gboolean _tmp0_;
	FILE* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 158 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 159 "valaccodewriter.vala"
	_tmp0_ = self->priv->_line_directives;
#line 159 "valaccodewriter.vala"
	if (_tmp0_) {
#line 160 "valaccodewriter.vala"
		if (line != NULL) {
#line 161 "valaccodewriter.vala"
			vala_ccode_node_write ((ValaCCodeNode*) line, self);
#line 162 "valaccodewriter.vala"
			self->priv->using_line_directive = TRUE;
#line 612 "valaccodewriter.c"
		} else {
#line 163 "valaccodewriter.vala"
			if (self->priv->using_line_directive) {
#line 616 "valaccodewriter.c"
				const gchar* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
#line 165 "valaccodewriter.vala"
				_tmp1_ = self->priv->_filename;
#line 165 "valaccodewriter.vala"
				_tmp2_ = g_path_get_basename (_tmp1_);
#line 165 "valaccodewriter.vala"
				_tmp3_ = _tmp2_;
#line 165 "valaccodewriter.vala"
				_tmp4_ = g_strdup_printf ("#line %d \"%s\"", self->priv->current_line_number + 1, _tmp3_);
#line 165 "valaccodewriter.vala"
				_tmp5_ = _tmp4_;
#line 165 "valaccodewriter.vala"
				vala_ccode_writer_write_string (self, _tmp5_);
#line 165 "valaccodewriter.vala"
				_g_free0 (_tmp5_);
#line 165 "valaccodewriter.vala"
				_g_free0 (_tmp3_);
#line 166 "valaccodewriter.vala"
				vala_ccode_writer_write_newline (self);
#line 167 "valaccodewriter.vala"
				self->priv->using_line_directive = FALSE;
#line 642 "valaccodewriter.c"
			}
		}
	}
#line 171 "valaccodewriter.vala"
	if (!self->priv->_bol) {
#line 172 "valaccodewriter.vala"
		vala_ccode_writer_write_newline (self);
#line 650 "valaccodewriter.c"
	}
#line 175 "valaccodewriter.vala"
	_tmp6_ = self->priv->stream;
#line 175 "valaccodewriter.vala"
	_tmp7_ = g_strnfill ((gsize) self->priv->indent, '\t');
#line 175 "valaccodewriter.vala"
	_tmp8_ = _tmp7_;
#line 175 "valaccodewriter.vala"
	fputs (_tmp8_, _tmp6_);
#line 175 "valaccodewriter.vala"
	_g_free0 (_tmp8_);
#line 176 "valaccodewriter.vala"
	self->priv->_bol = FALSE;
#line 664 "valaccodewriter.c"
}

/**
 * Writes n spaces.
 */
void
vala_ccode_writer_write_nspaces (ValaCCodeWriter* self,
                                 guint n)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 182 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 183 "valaccodewriter.vala"
	_tmp0_ = self->priv->stream;
#line 183 "valaccodewriter.vala"
	_tmp1_ = g_strnfill ((gsize) n, ' ');
#line 183 "valaccodewriter.vala"
	_tmp2_ = _tmp1_;
#line 183 "valaccodewriter.vala"
	fputs (_tmp2_, _tmp0_);
#line 183 "valaccodewriter.vala"
	_g_free0 (_tmp2_);
#line 689 "valaccodewriter.c"
}

/**
 * Writes the specified string.
 *
 * @param s a string
 */
void
vala_ccode_writer_write_string (ValaCCodeWriter* self,
                                const gchar* s)
{
	FILE* _tmp0_;
#line 191 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 191 "valaccodewriter.vala"
	g_return_if_fail (s != NULL);
#line 192 "valaccodewriter.vala"
	_tmp0_ = self->priv->stream;
#line 192 "valaccodewriter.vala"
	fputs (s, _tmp0_);
#line 193 "valaccodewriter.vala"
	self->priv->_bol = FALSE;
#line 712 "valaccodewriter.c"
}

/**
 * Writes a newline.
 */
void
vala_ccode_writer_write_newline (ValaCCodeWriter* self)
{
	FILE* _tmp0_;
	gint _tmp1_;
#line 199 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 200 "valaccodewriter.vala"
	if (!self->priv->_bol) {
#line 201 "valaccodewriter.vala"
		self->priv->_bael = FALSE;
#line 729 "valaccodewriter.c"
	} else {
#line 202 "valaccodewriter.vala"
		if (!self->priv->_bael) {
#line 203 "valaccodewriter.vala"
			self->priv->_bael = TRUE;
#line 735 "valaccodewriter.c"
		} else {
#line 205 "valaccodewriter.vala"
			return;
#line 739 "valaccodewriter.c"
		}
	}
#line 207 "valaccodewriter.vala"
	_tmp0_ = self->priv->stream;
#line 207 "valaccodewriter.vala"
	fputc ('\n', _tmp0_);
#line 208 "valaccodewriter.vala"
	_tmp1_ = self->priv->current_line_number;
#line 208 "valaccodewriter.vala"
	self->priv->current_line_number = _tmp1_ + 1;
#line 209 "valaccodewriter.vala"
	self->priv->_bol = TRUE;
#line 752 "valaccodewriter.c"
}

/**
 * Opens a new block, increasing the indent level.
 */
void
vala_ccode_writer_write_begin_block (ValaCCodeWriter* self)
{
	FILE* _tmp1_;
	gint _tmp2_;
#line 215 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 216 "valaccodewriter.vala"
	if (!self->priv->_bol) {
#line 767 "valaccodewriter.c"
		FILE* _tmp0_;
#line 217 "valaccodewriter.vala"
		_tmp0_ = self->priv->stream;
#line 217 "valaccodewriter.vala"
		fputc (' ', _tmp0_);
#line 773 "valaccodewriter.c"
	} else {
#line 219 "valaccodewriter.vala"
		vala_ccode_writer_write_indent (self, NULL);
#line 777 "valaccodewriter.c"
	}
#line 221 "valaccodewriter.vala"
	_tmp1_ = self->priv->stream;
#line 221 "valaccodewriter.vala"
	fputc ('{', _tmp1_);
#line 222 "valaccodewriter.vala"
	vala_ccode_writer_write_newline (self);
#line 223 "valaccodewriter.vala"
	_tmp2_ = self->priv->indent;
#line 223 "valaccodewriter.vala"
	self->priv->indent = _tmp2_ + 1;
#line 789 "valaccodewriter.c"
}

/**
 * Closes the current block, decreasing the indent level.
 */
void
vala_ccode_writer_write_end_block (ValaCCodeWriter* self)
{
	gint _tmp0_;
	FILE* _tmp1_;
#line 229 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 230 "valaccodewriter.vala"
	_vala_assert (self->priv->indent > 0, "indent > 0");
#line 232 "valaccodewriter.vala"
	_tmp0_ = self->priv->indent;
#line 232 "valaccodewriter.vala"
	self->priv->indent = _tmp0_ - 1;
#line 233 "valaccodewriter.vala"
	vala_ccode_writer_write_indent (self, NULL);
#line 234 "valaccodewriter.vala"
	_tmp1_ = self->priv->stream;
#line 234 "valaccodewriter.vala"
	fputc ('}', _tmp1_);
#line 814 "valaccodewriter.c"
}

/**
 * Writes the specified text as comment.
 *
 * @param text the comment text
 */
void
vala_ccode_writer_write_comment (ValaCCodeWriter* self,
                                 const gchar* text)
{
	GError* _inner_error0_ = NULL;
#line 242 "valaccodewriter.vala"
	g_return_if_fail (self != NULL);
#line 242 "valaccodewriter.vala"
	g_return_if_fail (text != NULL);
#line 831 "valaccodewriter.c"
	{
		FILE* _tmp0_;
		gboolean first = FALSE;
		GRegex* _tmp1_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		FILE* _tmp23_;
#line 244 "valaccodewriter.vala"
		vala_ccode_writer_write_indent (self, NULL);
#line 245 "valaccodewriter.vala"
		_tmp0_ = self->priv->stream;
#line 245 "valaccodewriter.vala"
		fputs ("/*", _tmp0_);
#line 246 "valaccodewriter.vala"
		first = TRUE;
#line 249 "valaccodewriter.vala"
		_tmp1_ = vala_ccode_writer_fix_indent_regex;
#line 249 "valaccodewriter.vala"
		if (_tmp1_ == NULL) {
#line 851 "valaccodewriter.c"
			GRegex* _tmp2_ = NULL;
			GRegex* _tmp3_;
			GRegex* _tmp4_;
#line 250 "valaccodewriter.vala"
			_tmp3_ = g_regex_new ("^\t+", 0, 0, &_inner_error0_);
#line 250 "valaccodewriter.vala"
			_tmp2_ = _tmp3_;
#line 250 "valaccodewriter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "valaccodewriter.vala"
				if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 863 "valaccodewriter.c"
					goto __catch0_g_regex_error;
				}
#line 250 "valaccodewriter.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "valaccodewriter.vala"
				g_clear_error (&_inner_error0_);
#line 250 "valaccodewriter.vala"
				return;
#line 872 "valaccodewriter.c"
			}
#line 250 "valaccodewriter.vala"
			_tmp4_ = _tmp2_;
#line 250 "valaccodewriter.vala"
			_tmp2_ = NULL;
#line 250 "valaccodewriter.vala"
			_g_regex_unref0 (vala_ccode_writer_fix_indent_regex);
#line 250 "valaccodewriter.vala"
			vala_ccode_writer_fix_indent_regex = _tmp4_;
#line 249 "valaccodewriter.vala"
			_g_regex_unref0 (_tmp2_);
#line 884 "valaccodewriter.c"
		}
#line 252 "valaccodewriter.vala"
		_tmp6_ = _tmp5_ = g_strsplit (text, "\n", 0);
#line 888 "valaccodewriter.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 252 "valaccodewriter.vala"
			line_collection = _tmp6_;
#line 252 "valaccodewriter.vala"
			line_collection_length1 = _vala_array_length (_tmp5_);
#line 252 "valaccodewriter.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 900 "valaccodewriter.c"
				const gchar* line = NULL;
#line 252 "valaccodewriter.vala"
				line = line_collection[line_it];
#line 904 "valaccodewriter.c"
				{
					gchar* _tmp7_ = NULL;
					GRegex* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar** lineparts = NULL;
					gchar** _tmp11_;
					gchar** _tmp12_;
					gint lineparts_length1;
					gint _lineparts_size_;
#line 253 "valaccodewriter.vala"
					if (!first) {
#line 254 "valaccodewriter.vala"
						vala_ccode_writer_write_indent (self, NULL);
#line 919 "valaccodewriter.c"
					} else {
#line 256 "valaccodewriter.vala"
						first = FALSE;
#line 923 "valaccodewriter.c"
					}
#line 259 "valaccodewriter.vala"
					_tmp8_ = vala_ccode_writer_fix_indent_regex;
#line 259 "valaccodewriter.vala"
					_tmp9_ = line;
#line 259 "valaccodewriter.vala"
					_tmp10_ = g_regex_replace_literal (_tmp8_, _tmp9_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 259 "valaccodewriter.vala"
					_tmp7_ = _tmp10_;
#line 259 "valaccodewriter.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "valaccodewriter.vala"
						line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 259 "valaccodewriter.vala"
						if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 939 "valaccodewriter.c"
							goto __catch0_g_regex_error;
						}
#line 259 "valaccodewriter.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "valaccodewriter.vala"
						g_clear_error (&_inner_error0_);
#line 259 "valaccodewriter.vala"
						return;
#line 948 "valaccodewriter.c"
					}
#line 259 "valaccodewriter.vala"
					_tmp12_ = _tmp11_ = g_strsplit (_tmp7_, "*/", 0);
#line 259 "valaccodewriter.vala"
					lineparts = _tmp12_;
#line 259 "valaccodewriter.vala"
					lineparts_length1 = _vala_array_length (_tmp11_);
#line 259 "valaccodewriter.vala"
					_lineparts_size_ = lineparts_length1;
#line 958 "valaccodewriter.c"
					{
						gint i = 0;
#line 261 "valaccodewriter.vala"
						i = 0;
#line 963 "valaccodewriter.c"
						{
							gboolean _tmp13_ = FALSE;
#line 261 "valaccodewriter.vala"
							_tmp13_ = TRUE;
#line 261 "valaccodewriter.vala"
							while (TRUE) {
#line 970 "valaccodewriter.c"
								gchar** _tmp15_;
								gint _tmp15__length1;
								const gchar* _tmp16_;
								FILE* _tmp17_;
								gchar** _tmp18_;
								gint _tmp18__length1;
								const gchar* _tmp19_;
								gchar** _tmp20_;
								gint _tmp20__length1;
								const gchar* _tmp21_;
#line 261 "valaccodewriter.vala"
								if (!_tmp13_) {
#line 983 "valaccodewriter.c"
									gint _tmp14_;
#line 261 "valaccodewriter.vala"
									_tmp14_ = i;
#line 261 "valaccodewriter.vala"
									i = _tmp14_ + 1;
#line 989 "valaccodewriter.c"
								}
#line 261 "valaccodewriter.vala"
								_tmp13_ = FALSE;
#line 261 "valaccodewriter.vala"
								_tmp15_ = lineparts;
#line 261 "valaccodewriter.vala"
								_tmp15__length1 = lineparts_length1;
#line 261 "valaccodewriter.vala"
								_tmp16_ = _tmp15_[i];
#line 261 "valaccodewriter.vala"
								if (!(_tmp16_ != NULL)) {
#line 261 "valaccodewriter.vala"
									break;
#line 1003 "valaccodewriter.c"
								}
#line 262 "valaccodewriter.vala"
								_tmp17_ = self->priv->stream;
#line 262 "valaccodewriter.vala"
								_tmp18_ = lineparts;
#line 262 "valaccodewriter.vala"
								_tmp18__length1 = lineparts_length1;
#line 262 "valaccodewriter.vala"
								_tmp19_ = _tmp18_[i];
#line 262 "valaccodewriter.vala"
								fputs (_tmp19_, _tmp17_);
#line 263 "valaccodewriter.vala"
								_tmp20_ = lineparts;
#line 263 "valaccodewriter.vala"
								_tmp20__length1 = lineparts_length1;
#line 263 "valaccodewriter.vala"
								_tmp21_ = _tmp20_[i + 1];
#line 263 "valaccodewriter.vala"
								if (_tmp21_ != NULL) {
#line 1023 "valaccodewriter.c"
									FILE* _tmp22_;
#line 264 "valaccodewriter.vala"
									_tmp22_ = self->priv->stream;
#line 264 "valaccodewriter.vala"
									fputs ("* /", _tmp22_);
#line 1029 "valaccodewriter.c"
								}
							}
						}
					}
#line 252 "valaccodewriter.vala"
					lineparts = (_vala_array_free (lineparts, lineparts_length1, (GDestroyNotify) g_free), NULL);
#line 252 "valaccodewriter.vala"
					_g_free0 (_tmp7_);
#line 1038 "valaccodewriter.c"
				}
			}
#line 252 "valaccodewriter.vala"
			line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1043 "valaccodewriter.c"
		}
#line 268 "valaccodewriter.vala"
		_tmp23_ = self->priv->stream;
#line 268 "valaccodewriter.vala"
		fputs ("*/", _tmp23_);
#line 269 "valaccodewriter.vala"
		vala_ccode_writer_write_newline (self);
#line 1051 "valaccodewriter.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 243 "valaccodewriter.vala"
		g_clear_error (&_inner_error0_);
#line 1058 "valaccodewriter.c"
	}
	__finally0:
#line 243 "valaccodewriter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "valaccodewriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 243 "valaccodewriter.vala"
		g_clear_error (&_inner_error0_);
#line 243 "valaccodewriter.vala"
		return;
#line 1069 "valaccodewriter.c"
	}
}

static void
vala_value_ccode_writer_init (GValue* value)
{
#line 28 "valaccodewriter.vala"
	value->data[0].v_pointer = NULL;
#line 1078 "valaccodewriter.c"
}

static void
vala_value_ccode_writer_free_value (GValue* value)
{
#line 28 "valaccodewriter.vala"
	if (value->data[0].v_pointer) {
#line 28 "valaccodewriter.vala"
		vala_ccode_writer_unref (value->data[0].v_pointer);
#line 1088 "valaccodewriter.c"
	}
}

static void
vala_value_ccode_writer_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 28 "valaccodewriter.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "valaccodewriter.vala"
		dest_value->data[0].v_pointer = vala_ccode_writer_ref (src_value->data[0].v_pointer);
#line 1100 "valaccodewriter.c"
	} else {
#line 28 "valaccodewriter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1104 "valaccodewriter.c"
	}
}

static gpointer
vala_value_ccode_writer_peek_pointer (const GValue* value)
{
#line 28 "valaccodewriter.vala"
	return value->data[0].v_pointer;
#line 1113 "valaccodewriter.c"
}

static gchar*
vala_value_ccode_writer_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 28 "valaccodewriter.vala"
	if (collect_values[0].v_pointer) {
#line 1124 "valaccodewriter.c"
		ValaCCodeWriter * object;
		object = collect_values[0].v_pointer;
#line 28 "valaccodewriter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "valaccodewriter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1131 "valaccodewriter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "valaccodewriter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1135 "valaccodewriter.c"
		}
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = vala_ccode_writer_ref (object);
#line 1139 "valaccodewriter.c"
	} else {
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = NULL;
#line 1143 "valaccodewriter.c"
	}
#line 28 "valaccodewriter.vala"
	return NULL;
#line 1147 "valaccodewriter.c"
}

static gchar*
vala_value_ccode_writer_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	ValaCCodeWriter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "valaccodewriter.vala"
	if (!object_p) {
#line 28 "valaccodewriter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1162 "valaccodewriter.c"
	}
#line 28 "valaccodewriter.vala"
	if (!value->data[0].v_pointer) {
#line 28 "valaccodewriter.vala"
		*object_p = NULL;
#line 1168 "valaccodewriter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "valaccodewriter.vala"
		*object_p = value->data[0].v_pointer;
#line 1172 "valaccodewriter.c"
	} else {
#line 28 "valaccodewriter.vala"
		*object_p = vala_ccode_writer_ref (value->data[0].v_pointer);
#line 1176 "valaccodewriter.c"
	}
#line 28 "valaccodewriter.vala"
	return NULL;
#line 1180 "valaccodewriter.c"
}

GParamSpec*
vala_param_spec_ccode_writer (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ValaParamSpecCCodeWriter* spec;
#line 28 "valaccodewriter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VALA_TYPE_CCODE_WRITER), NULL);
#line 28 "valaccodewriter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "valaccodewriter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "valaccodewriter.vala"
	return G_PARAM_SPEC (spec);
#line 1199 "valaccodewriter.c"
}

gpointer
vala_value_get_ccode_writer (const GValue* value)
{
#line 28 "valaccodewriter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_WRITER), NULL);
#line 28 "valaccodewriter.vala"
	return value->data[0].v_pointer;
#line 1209 "valaccodewriter.c"
}

void
vala_value_set_ccode_writer (GValue* value,
                             gpointer v_object)
{
	ValaCCodeWriter * old;
#line 28 "valaccodewriter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_WRITER));
#line 28 "valaccodewriter.vala"
	old = value->data[0].v_pointer;
#line 28 "valaccodewriter.vala"
	if (v_object) {
#line 28 "valaccodewriter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_WRITER));
#line 28 "valaccodewriter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = v_object;
#line 28 "valaccodewriter.vala"
		vala_ccode_writer_ref (value->data[0].v_pointer);
#line 1231 "valaccodewriter.c"
	} else {
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = NULL;
#line 1235 "valaccodewriter.c"
	}
#line 28 "valaccodewriter.vala"
	if (old) {
#line 28 "valaccodewriter.vala"
		vala_ccode_writer_unref (old);
#line 1241 "valaccodewriter.c"
	}
}

void
vala_value_take_ccode_writer (GValue* value,
                              gpointer v_object)
{
	ValaCCodeWriter * old;
#line 28 "valaccodewriter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALA_TYPE_CCODE_WRITER));
#line 28 "valaccodewriter.vala"
	old = value->data[0].v_pointer;
#line 28 "valaccodewriter.vala"
	if (v_object) {
#line 28 "valaccodewriter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALA_TYPE_CCODE_WRITER));
#line 28 "valaccodewriter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = v_object;
#line 1262 "valaccodewriter.c"
	} else {
#line 28 "valaccodewriter.vala"
		value->data[0].v_pointer = NULL;
#line 1266 "valaccodewriter.c"
	}
#line 28 "valaccodewriter.vala"
	if (old) {
#line 28 "valaccodewriter.vala"
		vala_ccode_writer_unref (old);
#line 1272 "valaccodewriter.c"
	}
}

static void
vala_ccode_writer_class_init (ValaCCodeWriterClass * klass,
                              gpointer klass_data)
{
#line 28 "valaccodewriter.vala"
	vala_ccode_writer_parent_class = g_type_class_peek_parent (klass);
#line 28 "valaccodewriter.vala"
	((ValaCCodeWriterClass *) klass)->finalize = vala_ccode_writer_finalize;
#line 28 "valaccodewriter.vala"
	g_type_class_adjust_private_offset (klass, &ValaCCodeWriter_private_offset);
#line 1286 "valaccodewriter.c"
}

static void
vala_ccode_writer_instance_init (ValaCCodeWriter * self,
                                 gpointer klass)
{
#line 28 "valaccodewriter.vala"
	self->priv = vala_ccode_writer_get_instance_private (self);
#line 59 "valaccodewriter.vala"
	self->priv->current_line_number = 1;
#line 63 "valaccodewriter.vala"
	self->priv->_bol = TRUE;
#line 65 "valaccodewriter.vala"
	self->priv->_bael = FALSE;
#line 28 "valaccodewriter.vala"
	self->ref_count = 1;
#line 1303 "valaccodewriter.c"
}

static void
vala_ccode_writer_finalize (ValaCCodeWriter * obj)
{
	ValaCCodeWriter * self;
#line 28 "valaccodewriter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_WRITER, ValaCCodeWriter);
#line 28 "valaccodewriter.vala"
	g_signal_handlers_destroy (self);
#line 32 "valaccodewriter.vala"
	_g_free0 (self->priv->_filename);
#line 37 "valaccodewriter.vala"
	_g_free0 (self->priv->source_filename);
#line 53 "valaccodewriter.vala"
	_g_free0 (self->priv->temp_filename);
#line 56 "valaccodewriter.vala"
	_fclose0 (self->priv->stream);
#line 1322 "valaccodewriter.c"
}

/**
 * Represents a writer to write C source files.
 */
static GType
vala_ccode_writer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { vala_value_ccode_writer_init, vala_value_ccode_writer_free_value, vala_value_ccode_writer_copy_value, vala_value_ccode_writer_peek_pointer, "p", vala_value_ccode_writer_collect_value, "p", vala_value_ccode_writer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeWriter), 0, (GInstanceInitFunc) vala_ccode_writer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType vala_ccode_writer_type_id;
	vala_ccode_writer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValaCCodeWriter", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ValaCCodeWriter_private_offset = g_type_add_instance_private (vala_ccode_writer_type_id, sizeof (ValaCCodeWriterPrivate));
	return vala_ccode_writer_type_id;
}

GType
vala_ccode_writer_get_type (void)
{
	static volatile gsize vala_ccode_writer_type_id__once = 0;
	if (g_once_init_enter (&vala_ccode_writer_type_id__once)) {
		GType vala_ccode_writer_type_id;
		vala_ccode_writer_type_id = vala_ccode_writer_get_type_once ();
		g_once_init_leave (&vala_ccode_writer_type_id__once, vala_ccode_writer_type_id);
	}
	return vala_ccode_writer_type_id__once;
}

gpointer
vala_ccode_writer_ref (gpointer instance)
{
	ValaCCodeWriter * self;
	self = instance;
#line 28 "valaccodewriter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "valaccodewriter.vala"
	return instance;
#line 1361 "valaccodewriter.c"
}

void
vala_ccode_writer_unref (gpointer instance)
{
	ValaCCodeWriter * self;
	self = instance;
#line 28 "valaccodewriter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "valaccodewriter.vala"
		VALA_CCODE_WRITER_GET_CLASS (self)->finalize (self);
#line 28 "valaccodewriter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1375 "valaccodewriter.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

